EnableExplicit

Enumeration
	#Window_Main
EndEnumeration

Enumeration
	#ButtonGadget
	#CheckBoxGadget
	#OptionGadget
	#StringGadget
EndEnumeration

Procedure GetGadgetUnderMouseCursor(Window.i, List Gadgets())
	Protected MouseX = WindowMouseX(Window)
	Protected MouseY = WindowMouseY(Window)
	
	ForEach Gadgets()
		If MouseX > GadgetX(Gadgets()) And MouseX < GadgetX(Gadgets())+GadgetWidth(Gadgets())
			If MouseY > GadgetY(Gadgets()) And MouseY < GadgetY(Gadgets())+GadgetHeight(Gadgets())
				ProcedureReturn Gadgets()
			EndIf
		EndIf
	Next
	ProcedureReturn -1
EndProcedure

Define.i i, Event, Drag_Active, Drag_Gadget, Drag_x_Offset, Drag_y_Offset
NewList Gadgets.i()

OpenWindow(#Window_Main, 300, 300, 500, 300, "Appuyer sur C pour deplacer un gadget", #PB_Window_SystemMenu|#PB_Window_TitleBar)

ButtonGadget(#ButtonGadget, 5, 5, 200, 30, "button")
CheckBoxGadget(#CheckBoxGadget, 5, 40, 200, 30, "checkbox")
OptionGadget(#OptionGadget, 5, 80, 200, 30, "option")
StringGadget(#StringGadget, 5, 120, 200, 30, "string")

For i = #ButtonGadget To #StringGadget
	AddElement(Gadgets())
	Gadgets() = i
Next

AddKeyboardShortcut(#Window_Main, #PB_Shortcut_C, 0)

Repeat
	Event = WaitWindowEvent()
	
	If Event = #PB_Event_Menu And EventMenu() = 0
		Drag_Active = Bool(Not Drag_Active)
		
		If Drag_Active
			Drag_Gadget = GetGadgetUnderMouseCursor(#Window_Main, Gadgets())
			If IsGadget(Drag_Gadget)
				Drag_x_Offset = WindowMouseX(#Window_Main)-GadgetX(Drag_Gadget)
				Drag_y_Offset = WindowMouseY(#Window_Main)-GadgetY(Drag_Gadget)
			EndIf
		EndIf
	EndIf
	
	If Drag_Active And IsGadget(Drag_Gadget)
		ResizeGadget(Drag_Gadget, WindowMouseX(#Window_Main)-Drag_x_Offset, WindowMouseY(#Window_Main)-Drag_y_Offset, #PB_Ignore, #PB_Ignore)
	EndIf
Until Event = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.40 LTS Beta 8 (Windows - x86)
; CursorPosition = 30
; FirstLine = 9
; Folding = -
; EnableXP