Structure MSLLHOOKSTRUCT
	pt.Point
	mouseData.l
	flags.l
	time.l
	; align.l pour x64
	*dwExtraInfo
EndStructure

#Main = 0

Global HHOOKMouse.i

Procedure LowLevelMouseProc(nCode.l, wParam.i, lParam.i)
	Protected *Pointer.MSLLHOOKSTRUCT, ID.l, Handle.i
	Static MemID.l, Exit.l = 0
	
	If nCode = #HC_ACTION
		*Pointer = lParam
		
		ScreenToClient_(WindowID(#Main), @*Pointer\pt)
		
		Handle = RealChildWindowFromPoint_(WindowID(#Main), *Pointer\pt\x + *Pointer\pt\y << 32)
		
		ID = GetDlgCtrlID_(Handle)
		
		
		Select wParam 
			Case #WM_MOUSEMOVE
				;Debug "WM_MOUSEMOVE" 
				If MemID <> ID
					If Exit = 0
						Exit = 1
						Debug "MOUSEMOVE ENTER"
						If ID <> 0
							Debug "Gadget ID = " + Str(ID)
						Else
							Debug "NO Gadget ID"
						EndIf
					Else
						Exit= 0
						Debug "MOUSEMOVE EXIT"
						If ID <> 0
							Debug "Gadget ID = " + Str(ID)
						Else
							Debug "NO Gadget ID"
						EndIf
					EndIf
				EndIf
				MemID = ID
				
			Case #WM_LBUTTONDOWN
				Debug "#WM_LBUTTONDOWN"
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"; + Str(ID)
				EndIf
				
			Case #WM_LBUTTONUP
				Debug "#WM_LBUTTONUP"
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"
				EndIf
				
			Case #WM_RBUTTONDOWN
				Debug "#WM_RBUTTONDOWN"
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"
				EndIf
				
			Case #WM_RBUTTONUP
				Debug "#WM_RBUTTONUP"
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"
				EndIf
				
			Case #WM_MBUTTONDOWN
				Debug "#WM_MBUTTONDOWN" 
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"
				EndIf
				
			Case #WM_MBUTTONUP
				Debug "#WM_MBUTTONUP"
				If ID <> 0
					Debug "Gadget ID = " + Str(ID)
				Else
					Debug "NO Gadget ID"
				EndIf
				
; 			Case #WM_MOUSEWHEEL
; 			  Debug "wheel"
			  
		EndSelect
		MemID = ID
	EndIf
	
	ProcedureReturn CallNextHookEx_(HHOOKMouse, nCode, wParam, lParam)
EndProcedure



If OpenWindow(#Main, 0, 0, 600, 600, "Mouse Hook", #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget |#PB_Window_ScreenCentered)
	; Ne pas commencer l'numration des gadgets par 0
	EditorGadget(0, 10, 10, 50, 50); ne doit pas tre 0  cause de GetDlgCtrlID_(Handle)
	ButtonGadget(1, 10, 60, 60,30,"ok")
	TextGadget(2,10,100,60,30,"texte")
	
	HHOOKMouse = SetWindowsHookEx_(#WH_MOUSE_LL, @LowLevelMouseProc(), GetModuleHandle_(0), 0)
	
	Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
	
	UnhookWindowsHookEx_(HHOOKLMouse)
EndIf 
; IDE Options = PureBasic 5.31 (Windows - x86)
; FirstLine = 38
; Folding = -
; EnableXP