Declare  mywindowcallback(windowid, message, wparam, lparam)

; *********** le Programme ***************************************************************************************************
hwnd = OpenWindow(0,0,0,500,400,"Window",#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_SizeGadget)
SetWindowCallback(@MyWindowCallback())

Repeat
		
		EventID=WaitWindowEvent()
		;;;Debug " Event = "+Str(EventID)
		
		Select EventID
				
				Case #PB_Event_CloseWindow
				End
		EndSelect
ForEver
; *******************************************************************************************************************************


;-** Zone Procedures
Procedure MyWindowCallback(WindowID, Message, wParam, lParam)
		Protected high.l, low.l
		Protected x.l, y.l
		Protected Delta.l
		Result = #PB_ProcessPureBasicEvents
		Select Message
				Case #WM_LBUTTONUP         : Debug "mouse LMB up"
				Case #WM_LBUTTONDOWN       : Debug "mouse LMB down"
				NewWx = WindowWidth(0)
				NewWy = WindowHeight(0)
				Case #WM_RBUTTONUP         : Debug "mouse RMB up"
				Case #WM_RBUTTONDOWN       : Debug "mouse RMB down"
				Case #WM_MBUTTONUP         : Debug "mouse MMB up"
				Case #WM_MBUTTONDOWN       : Debug "mouse MMB down"
				Case #WM_LBUTTONDBLCLK     : Debug "mouse LMB double-click"
				Case #WM_RBUTTONDBLCLK     : Debug "mouse RMB double-click"     
				Case #WM_MBUTTONDBLCLK     : Debug "mouse MMB double-click"
				Case #WM_MOUSEWHEEL        : Debug "mouse wheel"
				Case #WM_MOUSEMOVE         : Debug "mouse move"
				Case #WM_MOUSELEAVE        : Debug "mouse leave"
				Case #WM_MOUSELAST         : Debug "mouse last"
				Case #WM_MOUSEHOVER        : Debug "mouse hover"
				Case #WM_MOUSEFIRST        : Debug "mouse first"
				Case #WM_MOUSEACTIVATE     : Debug "mouse activate"
				Case #WM_MOUSEWHEEL
				high = wParam >> 16
				low = wParam & $FFFF
				x = lParam >> 16
				y = lParam & $FFFF
				; Position x et y de la souris par rapport  l'cran
				; et sans rapport donc avec la fentre o le control
				Debug "-----Position Souris-----"
				Debug x
				Debug y
				Delta = high * coef
				If Delta >= 120
						Debug "-----Positif-----"
						Debug delta
				ElseIf Delta <= -120
						Debug "-----Ngatif-----"
						Debug Delta
				EndIf
				
				;Ici, si la molette ne tourne pas, nous n'avons pas les notifications suivantes
				; Pas de elseif car la valeur de Low peut prendre plusieurs valeurs.
				If low & #MK_CONTROL ;0x0008 The CTRL key is down.
						;MessageRequester("Info", "Touche CTRL appuy, la molette tourne")
				EndIf
				If low & #MK_LBUTTON ;0x0001 The left mouse button is down
						MessageRequester("Info", "Bouton gauche souris appuy, la molette tourne")
				EndIf
				If low & #MK_MBUTTON ;0x0010 The middle mouse button is down
						MessageRequester("Info", "Bouton milieu souris appuy, la molette tourne")   
				EndIf
				If low & #MK_RBUTTON ;0x0002 The right mouse button is down
						MessageRequester("Info", "Bouton droit souris appuy, la molette tourne")     
				EndIf
				If low & #MK_SHIFT ;0x0004 The SHIFT key is down
						;MessageRequester("Info", "Touche SHIFT appuy, la molette tourne")   
				EndIf
				If low & #MK_XBUTTON1 ;0x0020 The first X button is down
						MessageRequester("Info", "Premier bouton X souris appuy, la molette tourne")   
				EndIf
				If low & #MK_XBUTTON2 ;0x0040 The second X button is down
						MessageRequester("Info", "Deuxime bouton X appuy, la molette tourne")
				EndIf
				
				; Au dessus, c'est pour l'exemple, dans une application, on fera par exemple:
				; Touche control + shift + molette augmente ou diminue un zoom suivant la rotation de la molette
				If low & #MK_CONTROL And low & #MK_SHIFT And Delta >= 120
						Debug "Zoom diminue"
				EndIf
				If low & #MK_CONTROL And low & #MK_SHIFT And Delta <= 120
						Debug "Zoom augmente"
				EndIf
				Resultat = 0
				Case #WM_NCMOUSEMOVE       : Debug "NC mouse move"
				Case #WM_NCLBUTTONDOWN     : Debug "NC mouse LMB"
				Case #WM_KEYDOWN           : Debug "key down"
				If lParam & $1000000
						Debug "Extended-key"
				Else
						Debug "Standard-key"
				EndIf
				Debug "Code: " + Str(wParam)
				Debug "Flags: " + RSet(Bin(lParam), 32, "0")
				Case #WM_KEYUP             : Debug "key UP"
				Case #WM_CHAR              : Debug "char"
				Case #WM_PAINT             : Debug "win paint"
				Case #WM_MOVING            : Debug "win moving"
				Case #WM_SIZING            : Debug "win sizing"
				Case #WM_MOVE              : Debug "win moved"
				Case #WM_CLOSE             : Debug "win closed"
				Case #WM_GETMINMAXINFO     : Debug "win sized"
				Case #WM_WINDOWPOSCHANGING : Debug "win pos changing"
				Case #WM_WINDOWPOSCHANGED  : Debug "win pos changed"
				Case #WM_SETCURSOR         : Debug "set cursor"
				Case #WM_NCHITTEST         : Debug "NC hit test"
				Case #WM_CTLCOLORBTN       : Debug "ctl color button"
				Case #WM_COMMAND           : Debug "wm command"
				Case #WM_CONTEXTMENU       : Debug "context menu"
				Case #WM_PARENTNOTIFY      : Debug "parent notify"
				Case #WM_ACTIVATE          : Debug "activate"
				Case #WM_NCACTIVATE        : Debug "NC activate"
				Case #WM_ACTIVATEAPP       : Debug "activate app"
				Case #WM_KILLFOCUS         : Debug "kill focus"
				Case #WM_GETICON           : Debug "get icon"
				Case #WM_SYSCOMMAND        : Debug "sys command"
				Case #WM_DESTROY           : Debug "destroy"
				Case #WM_NCDESTROY         : Debug "NC destroy"
				Default : ;;Debug ">> &H"+Hex(Message)
		EndSelect 
		ProcedureReturn Result
EndProcedure








;
; Epb


; IDE Options = PureBasic 5.40 LTS Beta 1 (Windows - x86)
; FirstLine = 63
; Folding = -
; EnableXP