﻿
;{ Include TabBarGadget
;|-------------------------------------------------------------------------------------------------
;|
;|  Title            : TabBarGadget
;|  Version          : 1.5 Beta 2 (2014-09-02)
;|  Copyright        : UnionBytes
;|                     (Martin Guttmann alias STARGÅTE)
;|  PureBasic        : 5.20+
;|  String Format    : Ascii, Unicode
;|  Operating System : Windows, Linux, MacOS
;|  Processor        : x86, x64
;|
;|-------------------------------------------------------------------------------------------------
;|
;|  Description      : Gadget for displaying and using tabs like in the browser
;|
;|  Forum Topic      : http://www.purebasic.fr/german/viewtopic.php?f=8&t=24788
;|                     http://www.purebasic.fr/english/viewtopic.php?f=12&t=47588
;|  Website          : http://www.unionbytes.de/includes/tabbargadget/
;|
;|  Documentation    : http://help.unionbytes.de/tbg/
;|
;|-------------------------------------------------------------------------------------------------
;}
XIncludeFile "TabBarGadget.pbi"
EnableExplicit
;- --- [N]  Window On The Top of the screen -------------------------------------------------------
;{ [TOP WINDOW] Enumeration
Enumeration Windows
  #Window_Main ; TopWindow
EndEnumeration

Enumeration Gadgets
  #MainWindow_Panel
  #WinMain_Panel_Container_GadgetStandard_ButtonPlus
  #WinMain_Panel_Container_GadgetStandard_ButtonMinus
EndEnumeration

Enumeration Menus
  #MenuItem_File_New
  #MenuItem_File_open
  #MenuItem_File_Close_Form
  #MenuItem_File_Save
  #MenuItem_File_SaveAs
  #MenuItem_File_SaveAll
  #MenuItem_File_RecentFiles_1
  #MenuItem_File_Import_PureFormDesigner
  #MenuItem_File_Import_ExternalImport
  #MenuItem_File_Exit
  #MenuItem_Edit_Undo
  #MenuItem_Edit_Cut
  #MenuItem_Edit_Copy
  #MenuItem_Edit_Paste
  #MenuItem_Delete
  #MenuItem_Edit_SelectAll
  #MenuItem_Edit_TabOrder
  #MenuItem_Edit_Gadget_Bringtofront
  #MenuItem_Edit_Gadget_Sendtoback
  #MenuItem_Edit_Gadget_Lock
  #MenuItem_Edit_Gadget_Unlock
  #MenuItem_Edit_Gadget_Noinsertin
  #MenuItem_Edit_Gadget_Nocopy
  #MenuItem_Edit_Align_Left
  #MenuItem_Edit_Align_Center
  #MenuItem_Edit_Align_Right
  #MenuItem_Edit_Align_Top
  #MenuItem_Edit_Align_Middle
  #MenuItem_Edit_Align_Bottom
  #MenuItem_Edit_Align_SpaceEquallyHorizontally
  #MenuItem_Edit_Align_SpaceEquallyVertically
  #MenuItem_Edit_Align_CenterHorizontallyInWindow
  #MenuItem_Edit_Align_CenterVerticallyInWindow
  #MenuItem_Edit_Align_EqualWidth
  #MenuItem_Edit_Align_EqualHeight
  #MenuItem_Edit_Align_EqualSizeht
  #MenuItem_Edit_Align_ToGrid
  #MenuItem_View_ObjectTree
  #MenuItem_View_ObjectInspector
  #MenuItem_View_FormList
  #MenuItem_View_Snippets
  #MenuItem_Options_Options
  #MenuItem_Options_RememberPosition
  #MenuItem_Tools_GeneratingFormCode
  #MenuItem_Tools_GeneratingOptions
  #MenuItem_Tools_RunForm
  #MenuItem_Tools_UpdateScript
  #MenuItem_Forms_Form1
  #MenuItem_Wizards_AllPlatforms
  #MenuItem_Wizards_Windows
  #MenuItem_Wizards_MacOs
  #MenuItem_Wizards_Linux
  #MenuItem_Snippets_AllPlatforms
  #MenuItem_Snippets_Windows
  #MenuItem_Snippets_MacOs
  #MenuItem_Snippets_Linux
  #MenuItem_Help_Content
  #MenuItem_Help_CheckLatestVersion
  #MenuItem_Help_About
EndEnumeration

Enumeration ToolBars
  ;ToolBar0 (up)
  #Toolbar0_New
  #Toolbar0_Open
  #Toolbar0_Save=#MenuItem_File_Save
  #Toolbar0_MakeCode=#MenuItem_Tools_GeneratingFormCode
  #Toolbar0_Run=#MenuItem_Tools_RunForm
  ;ToolBar1 (down)
  #Toolbar1_NewEmptyForm = #MenuItem_Help_About + 1
  #Toolbar1_Align = #MenuItem_Help_About + 2
  ;Toolbar TabStandard
  #Toolbar_TabStandard_acursor
  #Toolbar_TabStandard_button
  #Toolbar_TabStandard_buttonimage
  #Toolbar_TabStandard_calendar
  #Toolbar_TabStandard_canvas
  #Toolbar_TabStandard_checkbox
  #Toolbar_TabStandard_combobox
  #Toolbar_TabStandard_date
  #Toolbar_TabStandard_editor
  #Toolbar_TabStandard_hyperlink
  #Toolbar_TabStandard_image
  #Toolbar_TabStandard_ip
  #Toolbar_TabStandard_listicon
  #Toolbar_TabStandard_listview
  #Toolbar_TabStandard_opengl
  #Toolbar_TabStandard_option
  #Toolbar_TabStandard_progressbar
  #Toolbar_TabStandard_scroll_bar
  #Toolbar_TabStandard_shortcut
  #Toolbar_TabStandard_spin
  #Toolbar_TabStandard_string
  #Toolbar_TabStandard_text
  #Toolbar_TabStandard_trackbar
  #Toolbar_TabStandard_tree
  #Toolbar_TabStandard_web
  ;Toolbar TabMenus
  #Toolbar_TabMenus_acursor
  #Toolbar_TabMenus_menu
  #Toolbar_TabMenus_menuimage
  #Toolbar_TabMenus_menupopup
  #Toolbar_TabMenus_menupopupimage
  #Toolbar_TabMenus_toolbar
  ;Toolbar TabContainer
  #Toolbar_TabContainer_acursor
  #Toolbar_TabContainer_container
  #Toolbar_TabContainer_frame
  #Toolbar_TabContainer_panel
  #Toolbar_TabContainer_scrollarea
  #Toolbar_TabContainer_splitter
  ;Toolbar TabExplorer
  #Toolbar_TabExplorer_acursor
  #Toolbar_TabExplorer_explorercombo
  #Toolbar_TabExplorer_explorerlist
  #Toolbar_TabExplorer_explorertree
  ;Toolbar TabLayout
  #Toolbar_TabLayout_acursor
  #Toolbar_TabLayout_gridbox
  #Toolbar_TabLayout_hbox
  #Toolbar_TabLayout_multibox
  #Toolbar_TabLayout_singlebox
  #Toolbar_TabLayout_spacer
  #Toolbar_TabLayout_vbox
  ;Toolbar TabAdditional
  #Toolbar_TabAdditional_acursor
  #Toolbar_TabAdditional_mdi
  #Toolbar_TabAdditional_scintilla
  #Toolbar_TabAdditional_statusbar
  #Toolbar_TabAdditional_systray
  #Toolbar_TabAdditional_timer
  #Toolbar_TabAdditional_xml
  ;Toolbar TabCustom
  #Toolbar_TabCustom_acursor
  #Toolbar_TabCustom_shape
EndEnumeration

Enumeration ToolBars_Images
  ;ToolBar0
  #ToolBar0_Image_New
  #ToolBar0_Image_Open
  #ToolBar0_Image_Save
  #ToolBar0_Image_MakeCode
  #ToolBar0_Image_Run
  ;ToolBar1
  #ToolBar1_Image_NewEmptyForm
  #ToolBar1_Image_Align
  ;Toolbar TabStandard
  #Toolbar_TabStandard_Image_acursor
  #Toolbar_TabStandard_Image_button
  #Toolbar_TabStandard_Image_buttonimage
  #Toolbar_TabStandard_Image_calendar
  #Toolbar_TabStandard_Image_canvas
  #Toolbar_TabStandard_Image_checkbox
  #Toolbar_TabStandard_Image_combobox
  #Toolbar_TabStandard_Image_date
  #Toolbar_TabStandard_Image_editor
  #Toolbar_TabStandard_Image_hyperlink
  #Toolbar_TabStandard_Image_image
  #Toolbar_TabStandard_Image_ip
  #Toolbar_TabStandard_Image_listicon
  #Toolbar_TabStandard_Image_listview
  #Toolbar_TabStandard_Image_opengl
  #Toolbar_TabStandard_Image_option
  #Toolbar_TabStandard_Image_progressbar
  #Toolbar_TabStandard_Image_scroll_bar
  #Toolbar_TabStandard_Image_shortcut
  #Toolbar_TabStandard_Image_spin
  #Toolbar_TabStandard_Image_string
  #Toolbar_TabStandard_Image_text
  #Toolbar_TabStandard_Image_trackbar
  #Toolbar_TabStandard_Image_tree
  #Toolbar_TabStandard_Image_web
  ;  Toolbar TabStandard Buttons
  #Toolbar_TabStandard_Image_ButtonPlus
  #Toolbar_TabStandard_Image_ButtonMinus
  ;Toolbar TabMenus
  #Toolbar_TabMenus_Image_acursor
  #Toolbar_TabMenus_Image_menu
  #Toolbar_TabMenus_Image_menuimage
  #Toolbar_TabMenus_Image_menupopup
  #Toolbar_TabMenus_Image_menupopupimage
  #Toolbar_TabMenus_Image_toolbar
  ;Toolbar TabContainer
  #Toolbar_TabContainer_Image_acursor
  #Toolbar_TabContainer_Image_container
  #Toolbar_TabContainer_Image_frame
  #Toolbar_TabContainer_Image_panel
  #Toolbar_TabContainer_Image_scrollarea
  #Toolbar_TabContainer_Image_splitter
  ;Toolbar TabExplorer
  #Toolbar_TabExplorer_Image_acursor
  #Toolbar_TabExplorer_Image_explorercombo
  #Toolbar_TabExplorer_Image_explorerlist
  #Toolbar_TabExplorer_Image_explorertree
  ;Toolbar TabLayout
  #Toolbar_TabLayout_Image_acursor
  #Toolbar_TabLayout_Image_gridbox
  #Toolbar_TabLayout_Image_hbox
  #Toolbar_TabLayout_Image_multibox
  #Toolbar_TabLayout_Image_singlebox
  #Toolbar_TabLayout_Image_spacer
  #Toolbar_TabLayout_Image_vbox
  ;Toolbar TabAdditional
  #Toolbar_TabAdditional_Image_acursor
  #Toolbar_TabAdditional_Image_mdi
  #Toolbar_TabAdditional_Image_scintilla
  #Toolbar_TabAdditional_Image_statusbar
  #Toolbar_TabAdditional_Image_systray
  #Toolbar_TabAdditional_Image_timer
  #Toolbar_TabAdditional_Image_xml
  ;Toolbar TabCustom
  #Toolbar_TabCustom_Image_acursor
  #Toolbar_TabCustom_Image_shape
EndEnumeration
;}
;{ [TOP WINDOW] Global
Global IconPath$ ; Path to icons
Global DesktopRect.RECT ; Desktop's dimensions
Global DesktopWidth, DesktopHeight
Global hTB2 ; handle toolbar panel tab standard with butons "->" and "<-"
Global TopWindow_MouseLeftButton_Pressed, TopWindow_MouseLeftButton; Needed to use the 2 buttons on the tab "standard" to scroll icons left/right           
Global hButtonSpeedDOWN,  hButtonSpeedUP                           ; Needed to use the 2 buttons on the tab "standard" to scroll icons left/right
Global IndentIconsTabStandard                                      ; To shift icons (by 32 pixels) in the standard tab after a clic on a speedbutton
Global NbIconsInTabStandard                                        ; How many icons in the TabStandard, used withe speedbuttons
;}
;{ [TOP WINDOW] LoadImage for ToolBars
UsePNGImageDecoder()
IconPath$=GetCurrentDirectory()

;ToolBar0
LoadImage(#ToolBar0_Image_New,IconPath$ + "icons\toolbar0\new.png")
LoadImage(#ToolBar0_Image_Open,IconPath$ + "icons\toolbar0\open.png")
LoadImage(#ToolBar0_Image_Save,IconPath$ + "icons\toolbar0\save.png")
LoadImage(#ToolBar0_Image_MakeCode,IconPath$ + "icons\toolbar0\makecode.png")
LoadImage(#ToolBar0_Image_Run,IconPath$ + "icons\toolbar0\run.png")
;ToolBar1
LoadImage(#ToolBar1_Image_NewEmptyForm,IconPath$ + "icons\toolbar1\NewEmptyForm.png")
LoadImage(#ToolBar1_Image_Align,IconPath$ + "icons\toolbar1\Align.png")
;Toolbar TabStandard
LoadImage(#Toolbar_TabStandard_Image_acursor,IconPath$ + "\icons\panelgadgets\TabStandard\acursor.png")
LoadImage(#Toolbar_TabStandard_Image_button,IconPath$ + "\icons\panelgadgets\TabStandard\button.png")
LoadImage(#Toolbar_TabStandard_Image_buttonimage,IconPath$ + "\icons\panelgadgets\TabStandard\buttonimage.png")
LoadImage(#Toolbar_TabStandard_Image_calendar,IconPath$ + "\icons\panelgadgets\TabStandard\calendar.png")
LoadImage(#Toolbar_TabStandard_Image_canvas,IconPath$ + "\icons\panelgadgets\TabStandard\canvas.png")
LoadImage(#Toolbar_TabStandard_Image_checkbox,IconPath$ + "\icons\panelgadgets\TabStandard\checkbox.png")
LoadImage(#Toolbar_TabStandard_Image_combobox,IconPath$ + "\icons\panelgadgets\TabStandard\combobox.png")
LoadImage(#Toolbar_TabStandard_Image_date,IconPath$ + "\icons\panelgadgets\TabStandard\date.png")
LoadImage(#Toolbar_TabStandard_Image_editor,IconPath$ + "\icons\panelgadgets\TabStandard\editor.png")
LoadImage(#Toolbar_TabStandard_Image_hyperlink,IconPath$ + "\icons\panelgadgets\TabStandard\hyperlink.png")
LoadImage(#Toolbar_TabStandard_Image_image,IconPath$ + "\icons\panelgadgets\TabStandard\image.png")
LoadImage(#Toolbar_TabStandard_Image_ip,IconPath$ + "\icons\panelgadgets\TabStandard\ip.png")
LoadImage(#Toolbar_TabStandard_Image_listicon,IconPath$ + "\icons\panelgadgets\TabStandard\listicon.png")
LoadImage(#Toolbar_TabStandard_Image_listview,IconPath$ + "\icons\panelgadgets\TabStandard\listview.png")
LoadImage(#Toolbar_TabStandard_Image_opengl,IconPath$ + "\icons\panelgadgets\TabStandard\opengl.png")
LoadImage(#Toolbar_TabStandard_Image_option,IconPath$ + "\icons\panelgadgets\TabStandard\option.png")
LoadImage(#Toolbar_TabStandard_Image_progressbar,IconPath$ + "\icons\panelgadgets\TabStandard\progressbar.png")
LoadImage(#Toolbar_TabStandard_Image_scroll_bar,IconPath$ + "\icons\panelgadgets\TabStandard\scroll_bar.png")
LoadImage(#Toolbar_TabStandard_Image_shortcut,IconPath$ + "\icons\panelgadgets\TabStandard\shortcut.png")
LoadImage(#Toolbar_TabStandard_Image_spin,IconPath$ + "\icons\panelgadgets\TabStandard\spin.png")
LoadImage(#Toolbar_TabStandard_Image_string,IconPath$ + "\icons\panelgadgets\TabStandard\string.png")
LoadImage(#Toolbar_TabStandard_Image_text,IconPath$ + "\icons\panelgadgets\TabStandard\text.png")
LoadImage(#Toolbar_TabStandard_Image_trackbar,IconPath$ + "\icons\panelgadgets\TabStandard\trackbar.png")
LoadImage(#Toolbar_TabStandard_Image_tree,IconPath$ + "\icons\panelgadgets\TabStandard\tree.png")
LoadImage(#Toolbar_TabStandard_Image_web,IconPath$ + "\icons\panelgadgets\TabStandard\web.png")
;  Toolbar TabStandard Buttons
LoadImage(#Toolbar_TabStandard_Image_ButtonPlus,IconPath$ + "\icons\panelgadgets\TabStandard\resultset_next.png")
LoadImage(#Toolbar_TabStandard_Image_ButtonMinus,IconPath$ + "\icons\panelgadgets\TabStandard\resultset_previous.png")
;Toolbar TabMenus
LoadImage(#Toolbar_TabMenus_Image_acursor,IconPath$ + "\icons\panelgadgets\TabMenus\acursor.png")
LoadImage(#Toolbar_TabMenus_Image_menu,IconPath$ + "\icons\panelgadgets\TabMenus\menu.png")
LoadImage(#Toolbar_TabMenus_Image_menuimage,IconPath$ + "\icons\panelgadgets\TabMenus\menuimage.png")
LoadImage(#Toolbar_TabMenus_Image_menupopup,IconPath$ + "\icons\panelgadgets\TabMenus\menupopup.png")
LoadImage(#Toolbar_TabMenus_Image_menupopupimage,IconPath$ + "\icons\panelgadgets\TabMenus\menupopupimage.png")
LoadImage(#Toolbar_TabMenus_Image_toolbar,IconPath$ + "\icons\panelgadgets\TabMenus\toolbar.png")
;Toolbar TabContainer
LoadImage(#Toolbar_TabContainer_Image_acursor,IconPath$ + "\icons\panelgadgets\TabContainer\acursor.png")
LoadImage(#Toolbar_TabContainer_Image_container,IconPath$ + "\icons\panelgadgets\TabContainer\container.png")
LoadImage(#Toolbar_TabContainer_Image_frame,IconPath$ + "\icons\panelgadgets\TabContainer\frame.png")
LoadImage(#Toolbar_TabContainer_Image_panel,IconPath$ + "\icons\panelgadgets\TabContainer\panel.png")
LoadImage(#Toolbar_TabContainer_Image_scrollarea,IconPath$ + "\icons\panelgadgets\TabContainer\scrollarea.png")
LoadImage(#Toolbar_TabContainer_Image_splitter,IconPath$ + "\icons\panelgadgets\TabContainer\splitter.png")
;Toolbar TabExplorer
LoadImage(#Toolbar_TabExplorer_Image_acursor,IconPath$ + "\icons\panelgadgets\TabExplorer\acursor.png")
LoadImage(#Toolbar_TabExplorer_Image_explorercombo,IconPath$ + "\icons\panelgadgets\TabExplorer\explorercombo.png")
LoadImage(#Toolbar_TabExplorer_Image_explorerlist,IconPath$ + "\icons\panelgadgets\TabExplorer\explorerlist.png")
LoadImage(#Toolbar_TabExplorer_Image_explorertree,IconPath$ + "\icons\panelgadgets\TabExplorer\explorertree.png")
;Toolbar TabLayout
LoadImage(#Toolbar_TabLayout_Image_acursor,IconPath$ + "\icons\panelgadgets\TabLayout\acursor.png")
LoadImage(#Toolbar_TabLayout_Image_gridbox,IconPath$ + "\icons\panelgadgets\TabLayout\gridbox.png")
LoadImage(#Toolbar_TabLayout_Image_hbox,IconPath$ + "\icons\panelgadgets\TabLayout\hbox.png")
LoadImage(#Toolbar_TabLayout_Image_multibox,IconPath$ + "\icons\panelgadgets\TabLayout\multibox.png")
LoadImage(#Toolbar_TabLayout_Image_singlebox,IconPath$ + "\icons\panelgadgets\TabLayout\singlebox.png")
LoadImage(#Toolbar_TabLayout_Image_spacer,IconPath$ + "\icons\panelgadgets\TabLayout\spacer.png")
LoadImage(#Toolbar_TabLayout_Image_vbox,IconPath$ + "\icons\panelgadgets\TabLayout\vbox.png")
;Toolbar TabAdditional
LoadImage(#Toolbar_TabAdditional_Image_acursor,IconPath$ + "\icons\panelgadgets\TabAdditional\acursor.png")
LoadImage(#Toolbar_TabAdditional_Image_mdi,IconPath$ + "\icons\panelgadgets\TabAdditional\mdi.png")
LoadImage(#Toolbar_TabAdditional_Image_scintilla,IconPath$ + "\icons\panelgadgets\TabAdditional\scintilla.png")
LoadImage(#Toolbar_TabAdditional_Image_statusbar,IconPath$ + "\icons\panelgadgets\TabAdditional\statusbar.png")
LoadImage(#Toolbar_TabAdditional_Image_systray,IconPath$ + "\icons\panelgadgets\TabAdditional\systray.png")
LoadImage(#Toolbar_TabAdditional_Image_timer,IconPath$ + "\icons\panelgadgets\TabAdditional\timer.png")
LoadImage(#Toolbar_TabAdditional_Image_xml,IconPath$ + "\icons\panelgadgets\TabAdditional\xml.png")
;Toolbar TabCustom
LoadImage(#Toolbar_TabCustom_Image_acursor,IconPath$ + "\icons\panelgadgets\TabCustom\acursor.png")
LoadImage(#Toolbar_TabCustom_Image_shape,IconPath$ + "\icons\panelgadgets\TabCustom\shape.png")
;}
;{ [TOP WINDOW] Declare
;Declare 
;}
;{ [TOP WINDOW] Procedures
Procedure GetDesktopRect()
  
;   If  ExamineDesktops()
;     DesktopRect\bottom=DesktopHeight(0)
;     DesktopRect\left= 0
;     DesktopRect\right=DesktopWidth(0)
;     DesktopRect\top= 0
;     
;     DesktopWidth=DesktopRect\right
;     DesktopHeight=DesktopRect\bottom
;     
;     ProcedureReturn 1
;   EndIf
    If  ExamineDesktops()
    DesktopRect\bottom=GetSystemMetrics_(#SM_CYSCREEN)
    DesktopRect\left= 0
    DesktopRect\right=GetSystemMetrics_(#SM_CXSCREEN)
    DesktopRect\top= 0
    
    DesktopWidth=DesktopRect\right
    DesktopHeight=DesktopRect\bottom
    
    ProcedureReturn 1
  EndIf

  
EndProcedure
; Needed to use the 2 buttons on the tab "standard" to scroll icons left/right
Procedure SpeeButtonEvent(Window) 
  Protected UnderMouse.POINT, hButton 
  
  If GetActiveWindow_() = WindowID(Window) 
    GetCursorPos_(UnderMouse) 
    ;MapWindowPoints_(0, WindowID(Window), @UnderMouse, 1)
    ;hButton=RealChildWindowFromPoint_(WindowID(Window),UnderMouse\y << 32 + UnderMouse\x); 
    hButton=WindowFromPoint_(UnderMouse\y << 32 + UnderMouse\x)
    
    If TopWindow_MouseLeftButton_Pressed=0 And GetAsyncKeyState_(TopWindow_MouseLeftButton)<>0       
      TopWindow_MouseLeftButton_Pressed=1
      AddWindowTimer(Window,100,50)
      
    ElseIf TopWindow_MouseLeftButton_Pressed=1 And GetAsyncKeyState_(TopWindow_MouseLeftButton)=0 
      TopWindow_MouseLeftButton_Pressed=0 
      RemoveWindowTimer(Window,100)
      
    ElseIf TopWindow_MouseLeftButton_Pressed=1 And GetAsyncKeyState_(TopWindow_MouseLeftButton)<>0
      TopWindow_MouseLeftButton_Pressed=1     
    EndIf
    
  EndIf 
  
  ProcedureReturn hButton 
EndProcedure 
Procedure OpenWindow_Top(x = 0, y = 0, width = 760, height = 110)
  Protected IconWidth, IconHeight, ButtonIconWidth, ButtonIconHeight, ButtonIconMargin
  Protected containerTB0, hTB0, hOldIList, hNewIList
  Protected containerTB1, hTB1
  Protected MainWindowClientHeight, PanelClientHeight, ButtonPlusMinusWidth, containerTabStandard
  Protected containerTabMenus, hTB3, containerTabContainer, hTB4, containerTabExplorer, hTB5 
  Protected containerTabLayout, hTB6, containerTabAdditonal, hTB7, containerTabCustom, hTB8
  Protected ToolBarsLength, tmp, Margin, TopWindowHeight
  
  OpenWindow(#Window_Main, x, y, DesktopWidth , height, "Pure Dialog Designer", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget|#PB_Window_Invisible)
  ;{ Shortcuts
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_N, #MenuItem_File_New)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_O, #MenuItem_File_open)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_Q, #MenuItem_File_Close_Form)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_S, #MenuItem_File_Save)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_Shift, #MenuItem_File_SaveAs)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_Alt, #MenuItem_File_SaveAll)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Alt | #PB_Shortcut_F4, #MenuItem_File_Exit)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_Z, #MenuItem_Edit_Undo)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_X, #MenuItem_Edit_Cut)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_C, #MenuItem_Edit_Copy)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_V, #MenuItem_Edit_Paste)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_A, #MenuItem_Edit_SelectAll)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_T, #MenuItem_Edit_TabOrder)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_1, #MenuItem_View_ObjectTree)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_2, #MenuItem_View_ObjectInspector)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_3, #MenuItem_View_FormList)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_4, #MenuItem_View_Snippets)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_K, #MenuItem_Options_Options)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_F9, #MenuItem_Tools_GeneratingFormCode)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_F9, #MenuItem_Tools_GeneratingOptions)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_F10, #MenuItem_Tools_RunForm)
  AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Control | #PB_Shortcut_U, #MenuItem_Tools_UpdateScript)
  ;}
  ;{ Menu
  CreateMenu(0, WindowID(#Window_Main))
  MenuTitle("&File")
  MenuItem(#MenuItem_File_New, "&New" + Chr(9) + "Ctrl+N")
  MenuItem(#MenuItem_File_open, "&Open" + Chr(9) + "Ctrl+O")
  MenuItem(#MenuItem_File_Close_Form, "&Close Form" + Chr(9) + "Ctrl+Q")
  MenuBar()
  MenuItem(#MenuItem_File_Save, "&Save" + Chr(9) + "Ctrl+S")
  MenuItem(#MenuItem_File_SaveAs, "Save &As" + Chr(9) + "Ctrl+Shift+S")
  MenuItem(#MenuItem_File_SaveAll, "Save all" + Chr(9) + "Ctrl+Alt+S")
  MenuBar()
  OpenSubMenu("&Recent files")
  MenuItem(#MenuItem_File_RecentFiles_1, "...")
  CloseSubMenu()
  OpenSubMenu("&Import")
  MenuItem(#MenuItem_File_Import_PureFormDesigner, "Import PureForm Designer")
  MenuItem(#MenuItem_File_Import_ExternalImport, "External Import...")
  CloseSubMenu()
  MenuBar()
  MenuItem(#MenuItem_File_Exit, "E&xit" + Chr(9) + "Alt+F4")
  MenuTitle("&Edit")
  MenuItem(#MenuItem_Edit_Undo, "&Undo" + Chr(9) + "Ctrl+Z")
  MenuBar()
  MenuItem(#MenuItem_Edit_Cut, "Cu&t" + Chr(9) + "Ctrl+X")
  MenuItem(#MenuItem_Edit_Copy, "&Copy" + Chr(9) + "Ctrl+C")
  MenuItem(#MenuItem_Edit_Paste, "&Paste" + Chr(9) + "Ctrl+V")
  MenuBar()
  MenuItem(#MenuItem_Delete, "&Delete")
  MenuBar()
  MenuItem(#MenuItem_Edit_SelectAll, "Select &All" + Chr(9) + "Ctrl+A")
  MenuItem(#MenuItem_Edit_TabOrder, "Tab &Order" + Chr(9) + "Ctrl+T")
  OpenSubMenu("&Gadget")
  MenuItem(#MenuItem_Edit_Gadget_Bringtofront, "Bring to front")
  MenuItem(#MenuItem_Edit_Gadget_Sendtoback, "Send to back")
  MenuBar()
  MenuItem(#MenuItem_Edit_Gadget_Lock, "Lock")
  MenuItem(#MenuItem_Edit_Gadget_Unlock, "Unlock")
  MenuItem(#MenuItem_Edit_Gadget_Noinsertin, "No insert in")
  MenuItem(#MenuItem_Edit_Gadget_Nocopy, "No copy")
  CloseSubMenu()
  OpenSubMenu("Align")
  MenuItem(#MenuItem_Edit_Align_Left, "Left")
  MenuItem(#MenuItem_Edit_Align_Center, "Center")
  MenuItem(#MenuItem_Edit_Align_Right, "Right")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_Top, "Top")
  MenuItem(#MenuItem_Edit_Align_Middle, "Middle")
  MenuItem(#MenuItem_Edit_Align_Bottom, "Bottom")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_SpaceEquallyHorizontally, "Space Equally Horizontally")
  MenuItem(#MenuItem_Edit_Align_SpaceEquallyVertically, "Space Equally Vertically")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_CenterHorizontallyInWindow, "Center Horizontally In Window")
  MenuItem(#MenuItem_Edit_Align_CenterVerticallyInWindow, "Center Vertically In Window")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_EqualWidth, "Equal Width")
  MenuItem(#MenuItem_Edit_Align_EqualHeight, "Equal Height")
  MenuItem(#MenuItem_Edit_Align_EqualSizeht, "Equal Size")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_ToGrid, "Align To Grid")
  CloseSubMenu()
  
  MenuTitle("&View")
  MenuItem(#MenuItem_View_ObjectTree, "Object Tree" + Chr(9) + "Ctrl+1")
  MenuItem(#MenuItem_View_ObjectInspector, "Object Inspector" + Chr(9) + "Ctrl+2")
  MenuItem(#MenuItem_View_FormList, "Form List" + Chr(9) + "Ctrl+3")
  MenuItem(#MenuItem_View_Snippets, "Snippets" + Chr(9) + "Ctrl+4")
  MenuTitle("&Options")
  MenuItem(#MenuItem_Options_Options, "&Options..." + Chr(9) + "Ctrl+K")
  MenuBar()
  MenuItem(#MenuItem_Options_RememberPosition, "Remember Position")
  MenuTitle("&Tools")
  MenuItem(#MenuItem_Tools_GeneratingFormCode, "&Generating Form Code..." + Chr(9) + "F9")
  MenuItem(#MenuItem_Tools_GeneratingOptions, "&Generating Options..." + Chr(9) + "Ctrl+F9")
  MenuItem(#MenuItem_Tools_RunForm, "&Run Form" + Chr(9) + "F10")
  MenuBar()
  MenuItem(#MenuItem_Tools_UpdateScript, "Update Script" + Chr(9) + "Ctrl+U")
  MenuTitle("For&ms")
  MenuItem(#MenuItem_Forms_Form1, "Form1")
  MenuTitle("&Wizards")
  MenuItem(#MenuItem_Wizards_AllPlatforms, "&All Platforms")
  MenuBar()
  MenuItem(#MenuItem_Wizards_Windows, "&Windows")
  MenuItem(#MenuItem_Wizards_MacOs, "&MacOs")
  MenuItem(#MenuItem_Wizards_Linux, "&Linux")
  MenuTitle("&Snippets")
  MenuItem(#MenuItem_Snippets_AllPlatforms, "&All Platforms")
  MenuBar()
  MenuItem(#MenuItem_Snippets_Windows, "&Windows")
  MenuItem(#MenuItem_Snippets_MacOs, "&MacOs")
  MenuItem(#MenuItem_Snippets_Linux, "&Linux")
  MenuTitle("&Help")
  MenuItem(#MenuItem_Help_Content, "&Content")
  MenuBar()
  MenuItem(#MenuItem_Help_CheckLatestVersion, "Check Latest &Version")
  MenuBar()
  MenuItem(#MenuItem_Help_About, "&About...")
  ;}
  ;{ ToolBar0
  IconWidth=32
  IconHeight=32
  ButtonIconWidth=32
  ButtonIconHeight=32
  ButtonIconMargin=2*6
  containerTB0=ContainerGadget(#PB_Any, 0, 0, 210, ButtonIconHeight+ButtonIconMargin)
  ;SetGadgetColor(containerTB0,#PB_Gadget_BackColor,$00ff00)
  hTB0=CreateToolBar(0, GadgetID(containerTB0))
  hOldIList = SendMessage_(hTB0, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB0, #TB_SETIMAGELIST, 0, hNewIList)
  SendMessage_(hTB0, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  SendMessage_(hTB0, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB0, #TB_AUTOSIZE, 0, 0)
  ToolBarImageButton(#Toolbar0_New,ImageID(#ToolBar0_Image_New))
  ToolBarToolTip(0, #Toolbar0_New, "New Form project")
  ToolBarImageButton(#Toolbar0_Open,ImageID(#ToolBar0_Image_Open))
  ToolBarToolTip(0, #Toolbar0_Open, "Open Form")
  ToolBarImageButton(#Toolbar0_Save,ImageID(#ToolBar0_Image_Save))
  ToolBarToolTip(0, #Toolbar0_Save, "Save Form")
  ToolBarSeparator()
  ToolBarImageButton(#Toolbar0_MakeCode,ImageID(#ToolBar0_Image_MakeCode))
  ToolBarToolTip(0, #Toolbar0_MakeCode, "Generate code")
  ToolBarImageButton(#Toolbar0_Run,ImageID(#ToolBar0_Image_Run))
  ToolBarToolTip(0, #Toolbar0_Run, "Run and Preview")
  CloseGadgetList()
  ;}
  ;{ ToolBar1 
  containerTB1=ContainerGadget(#PB_Any, 0, GadgetHeight(containerTB0), 210, ButtonIconHeight+ButtonIconMargin)
  ;SetGadgetColor(containerTB1,#PB_Gadget_BackColor,$00ff00)
  hTB1=CreateToolBar(1, GadgetID(containerTB1))
  hOldIList = SendMessage_(hTB1, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB1, #TB_SETIMAGELIST, 0, hNewIList)
  SendMessage_(hTB1, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  SendMessage_(hTB1, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB1, #TB_AUTOSIZE, 0, 0)
  ToolBarImageButton(#Toolbar1_NewEmptyForm,ImageID(#ToolBar1_Image_NewEmptyForm))
  ToolBarToolTip(1, #Toolbar1_NewEmptyForm, "New Empty Form")
  ToolBarImageButton(#Toolbar1_Align,ImageID(#ToolBar1_Image_Align))
  ToolBarToolTip(1, #Toolbar1_Align, "Align")
  CloseGadgetList() 
  ;}
  ;{ Panel
  
  ; Needed to use the 2 buttons on the tab "standard" to scroll icons left/right
  If GetSystemMetrics_(#SM_SWAPBUTTON)=0 
    TopWindow_MouseLeftButton=#VK_LBUTTON 
  Else 
    TopWindow_MouseLeftButton=#VK_RBUTTON 
  EndIf 
  
  ; Go !
  MainWindowClientHeight=GadgetHeight(containerTB0)+GadgetHeight(containerTB1)
  
  ;Panel
  PanelGadget(#MainWindow_Panel, 210, 0, 610, MainWindowClientHeight)
  
  ; >Tab Standard
  ;==============
  AddGadgetItem(#MainWindow_Panel, -1, "Standard")
  PanelClientHeight=MainWindowClientHeight-GetGadgetAttribute(#MainWindow_Panel,#PB_Panel_TabHeight)
  ButtonPlusMinusWidth=20
  containerTabStandard=ContainerGadget(#PB_Any, 0, 0, 580, PanelClientHeight)
  ; SetGadgetColor(containerTabStandard,#PB_Gadget_BackColor,$00ff00)
  hTB2=CreateToolBar(2, GadgetID(containerTabStandard))
  ;toolbar in color to debug things
  ; dwStyle = #WS_CHILD | #WS_VISIBLE | #CCS_TOP | #CCS_NODIVIDER | #TBSTYLE_FLAT
  ; hBrushBack = CreateSolidBrush_(#Red)
  ; SetWindowLong_(hTB2,#GWL_STYLE,dwStyle)
  ; SetClassLong_(hTB2,#GCL_HBRBACKGROUND,hBrushBack)
  ;delete the upper line
  SendMessage_(hTB2,#TB_SETSTYLE,0,SendMessage_(hTB2,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB2, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB2, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB2, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB2, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB2, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabStandard_acursor,ImageID(#Toolbar_TabStandard_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabStandard_button,ImageID(#Toolbar_TabStandard_Image_button))
  ToolBarImageButton(#Toolbar_TabStandard_buttonimage,ImageID(#Toolbar_TabStandard_Image_buttonimage))
  ToolBarImageButton(#Toolbar_TabStandard_calendar,ImageID(#Toolbar_TabStandard_Image_calendar))
  ToolBarImageButton(#Toolbar_TabStandard_canvas,ImageID(#Toolbar_TabStandard_Image_canvas))
  ToolBarImageButton(#Toolbar_TabStandard_checkbox,ImageID(#Toolbar_TabStandard_Image_checkbox))
  ToolBarImageButton(#Toolbar_TabStandard_combobox,ImageID(#Toolbar_TabStandard_Image_combobox))
  ToolBarImageButton(#Toolbar_TabStandard_date,ImageID(#Toolbar_TabStandard_Image_date))
  ToolBarImageButton(#Toolbar_TabStandard_editor,ImageID(#Toolbar_TabStandard_Image_editor))
  ToolBarImageButton(#Toolbar_TabStandard_hyperlink,ImageID(#Toolbar_TabStandard_Image_hyperlink))
  ToolBarImageButton(#Toolbar_TabStandard_image,ImageID(#Toolbar_TabStandard_Image_image))
  ToolBarImageButton(#Toolbar_TabStandard_ip,ImageID(#Toolbar_TabStandard_Image_ip))
  ToolBarImageButton(#Toolbar_TabStandard_listicon,ImageID(#Toolbar_TabStandard_Image_listicon))
  ToolBarImageButton(#Toolbar_TabStandard_listview,ImageID(#Toolbar_TabStandard_Image_listview))
  ToolBarImageButton(#Toolbar_TabStandard_opengl,ImageID(#Toolbar_TabStandard_Image_opengl))
  ToolBarImageButton(#Toolbar_TabStandard_option,ImageID(#Toolbar_TabStandard_Image_option))
  ToolBarImageButton(#Toolbar_TabStandard_progressbar,ImageID(#Toolbar_TabStandard_Image_progressbar))
  ToolBarImageButton(#Toolbar_TabStandard_scroll_bar,ImageID(#Toolbar_TabStandard_Image_scroll_bar))
  ToolBarImageButton(#Toolbar_TabStandard_shortcut,ImageID(#Toolbar_TabStandard_Image_shortcut))
  ToolBarImageButton(#Toolbar_TabStandard_spin,ImageID(#Toolbar_TabStandard_Image_spin))
  ToolBarImageButton(#Toolbar_TabStandard_string,ImageID(#Toolbar_TabStandard_Image_string))
  ToolBarImageButton(#Toolbar_TabStandard_text,ImageID(#Toolbar_TabStandard_Image_text))
  ToolBarImageButton(#Toolbar_TabStandard_trackbar,ImageID(#Toolbar_TabStandard_Image_trackbar))
  ToolBarImageButton(#Toolbar_TabStandard_tree,ImageID(#Toolbar_TabStandard_Image_tree))
  ToolBarImageButton(#Toolbar_TabStandard_web,ImageID(#Toolbar_TabStandard_Image_web))
  ToolBarToolTip(2, #Toolbar_TabStandard_acursor, "acursor")
  ToolBarToolTip(2, #Toolbar_TabStandard_button, "button")
  ToolBarToolTip(2, #Toolbar_TabStandard_buttonimage, "buttonimage")
  ToolBarToolTip(2, #Toolbar_TabStandard_calendar, "calendar")
  ToolBarToolTip(2, #Toolbar_TabStandard_canvas, "canvas")
  ToolBarToolTip(2, #Toolbar_TabStandard_checkbox, "checkbox")
  ToolBarToolTip(2, #Toolbar_TabStandard_combobox, "combobox")
  ToolBarToolTip(2, #Toolbar_TabStandard_date, "date")
  ToolBarToolTip(2, #Toolbar_TabStandard_editor, "editor")
  ToolBarToolTip(2, #Toolbar_TabStandard_hyperlink, "hyperlink")
  ToolBarToolTip(2, #Toolbar_TabStandard_image, "image")
  ToolBarToolTip(2, #Toolbar_TabStandard_ip, "ip")
  ToolBarToolTip(2, #Toolbar_TabStandard_listicon, "listicon")
  ToolBarToolTip(2, #Toolbar_TabStandard_listview, "listview")
  ToolBarToolTip(2, #Toolbar_TabStandard_opengl, "opengl")
  ToolBarToolTip(2, #Toolbar_TabStandard_option, "option")
  ToolBarToolTip(2, #Toolbar_TabStandard_progressbar, "progressbar")
  ToolBarToolTip(2, #Toolbar_TabStandard_scroll_bar, "scroll_bar")
  ToolBarToolTip(2, #Toolbar_TabStandard_shortcut, "shortcut")
  ToolBarToolTip(2, #Toolbar_TabStandard_spin, "spin")
  ToolBarToolTip(2, #Toolbar_TabStandard_string, "string")
  ToolBarToolTip(2, #Toolbar_TabStandard_text, "text")
  ToolBarToolTip(2, #Toolbar_TabStandard_trackbar, "trackbar")
  ToolBarToolTip(2, #Toolbar_TabStandard_tree, "tree")
  ToolBarToolTip(2, #Toolbar_TabStandard_web, "web")
  ; close the container
  CloseGadgetList()
  NbIconsInTabStandard = SendMessage_(hTB2, #TB_BUTTONCOUNT, 0, 0) ; How many icons in the TabStandard
                                                                   ;Buttons "->" and "<-" needed to scroll icons left/right (because there are too much icons to display on
  hButtonSpeedUP=ButtonImageGadget(#WinMain_Panel_Container_GadgetStandard_ButtonPlus,GadgetWidth(containerTabStandard),0,ButtonPlusMinusWidth,PanelClientHeight/2,ImageID(#Toolbar_TabStandard_Image_ButtonPlus))
  hButtonSpeedDOWN=ButtonImageGadget(#WinMain_Panel_Container_GadgetStandard_ButtonMinus,GadgetWidth(containerTabStandard),PanelClientHeight/2,ButtonPlusMinusWidth,PanelClientHeight/2,ImageID(#Toolbar_TabStandard_Image_ButtonMinus))
  
  ; >Tab Menus and Toolbars
  ;==========================
  AddGadgetItem(#MainWindow_Panel, -1, "Menus + ToolBars", 0, 1)
  containerTabMenus=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ; SetGadgetColor(containerTabMenus,#PB_Gadget_BackColor,$00ff00)
  hTB3=CreateToolBar(3, GadgetID(containerTabMenus))
  ;delete the upper line
  SendMessage_(hTB3,#TB_SETSTYLE,0,SendMessage_(hTB3,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB3, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB3, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB3, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB3, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB3, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabMenus_acursor,ImageID(#Toolbar_TabMenus_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabMenus_menu,ImageID(#Toolbar_TabMenus_Image_menu))
  ToolBarImageButton(#Toolbar_TabMenus_menuimage,ImageID(#Toolbar_TabMenus_Image_menuimage))
  ToolBarImageButton(#Toolbar_TabMenus_menupopup,ImageID(#Toolbar_TabMenus_Image_menupopup))
  ToolBarImageButton(#Toolbar_TabMenus_menupopupimage,ImageID(#Toolbar_TabMenus_Image_menupopupimage))
  ToolBarImageButton(#Toolbar_TabMenus_toolbar,ImageID(#Toolbar_TabMenus_Image_toolbar))
  ToolBarToolTip(3,#Toolbar_TabMenus_acursor, "acursor")
  ToolBarToolTip(3,#Toolbar_TabMenus_menu, "menu")
  ToolBarToolTip(3,#Toolbar_TabMenus_menuimage, "menuimage")
  ToolBarToolTip(3,#Toolbar_TabMenus_menupopup, "menupopup")
  ToolBarToolTip(3,#Toolbar_TabMenus_menupopupimage, "menupopupimage")
  ToolBarToolTip(3,#Toolbar_TabMenus_toolbar, "toolbar")  
  CloseGadgetList() 
  
  ; >Tab Container
  ;======================
  AddGadgetItem(#MainWindow_Panel, -1, "Container", 0, 1)
  containerTabContainer=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ; SetGadgetColor(containerTabMenus,#PB_Gadget_BackColor,$00ff00)
  hTB4=CreateToolBar(4, GadgetID(containerTabContainer))
  ;delete the upper line
  SendMessage_(hTB4,#TB_SETSTYLE,0,SendMessage_(hTB4,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB4, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB4, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB4, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB4, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB4, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabContainer_acursor,ImageID(#Toolbar_TabContainer_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabContainer_container,ImageID(#Toolbar_TabContainer_Image_container))
  ToolBarImageButton(#Toolbar_TabContainer_frame,ImageID(#Toolbar_TabContainer_Image_frame))
  ToolBarImageButton(#Toolbar_TabContainer_panel,ImageID(#Toolbar_TabContainer_Image_panel))
  ToolBarImageButton(#Toolbar_TabContainer_scrollarea,ImageID(#Toolbar_TabContainer_Image_scrollarea))
  ToolBarImageButton(#Toolbar_TabContainer_splitter,ImageID(#Toolbar_TabContainer_Image_splitter))
  ToolBarToolTip(4,#Toolbar_TabContainer_acursor, "acursor")
  ToolBarToolTip(4,#Toolbar_TabContainer_container, "container")
  ToolBarToolTip(4,#Toolbar_TabContainer_frame, "frame")
  ToolBarToolTip(4,#Toolbar_TabContainer_panel, "panel")
  ToolBarToolTip(4,#Toolbar_TabContainer_scrollarea, "scrollarea")
  ToolBarToolTip(4,#Toolbar_TabContainer_splitter, "splitter")
  CloseGadgetList()
  
  ; >Tab Explorer
  ;=============
  AddGadgetItem(#MainWindow_Panel, -1, "Explorer", 0, 1)
  containerTabExplorer=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ; SetGadgetColor(containerTabMenus,#PB_Gadget_BackColor,$00ff00)
  hTB5=CreateToolBar(5, GadgetID(containerTabExplorer))
  ;delete the upper line
  SendMessage_(hTB5,#TB_SETSTYLE,0,SendMessage_(hTB5,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB5, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB5, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB5, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB5, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB5, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabExplorer_acursor,ImageID(#Toolbar_TabExplorer_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabExplorer_explorercombo,ImageID(#Toolbar_TabExplorer_Image_explorercombo))
  ToolBarImageButton(#Toolbar_TabExplorer_explorerlist,ImageID(#Toolbar_TabExplorer_Image_explorerlist))
  ToolBarImageButton(#Toolbar_TabExplorer_explorertree,ImageID(#Toolbar_TabExplorer_Image_explorertree))
  ToolBarToolTip(5,#Toolbar_TabExplorer_acursor, "acursor")
  ToolBarToolTip(5,#Toolbar_TabExplorer_explorercombo, "explorercombo")
  ToolBarToolTip(5,#Toolbar_TabExplorer_explorerlist, "explorerlist")
  ToolBarToolTip(5,#Toolbar_TabExplorer_explorertree, "explorertree")
  CloseGadgetList()
  
  ; >Tab Layout
  ;=============
  AddGadgetItem(#MainWindow_Panel, -1, "Layout", 0, 2)
  containerTabLayout=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ; SetGadgetColor(containerTabMenus,#PB_Gadget_BackColor,$00ff00)
  hTB6=CreateToolBar(6, GadgetID(containerTabLayout))
  ;delete the upper line
  SendMessage_(hTB6,#TB_SETSTYLE,0,SendMessage_(hTB6,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB6, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB6, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB6, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB6, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB6, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabLayout_acursor,ImageID(#Toolbar_TabLayout_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabLayout_gridbox,ImageID(#Toolbar_TabLayout_Image_gridbox))
  ToolBarImageButton(#Toolbar_TabLayout_hbox,ImageID(#Toolbar_TabLayout_Image_hbox))
  ToolBarImageButton(#Toolbar_TabLayout_multibox,ImageID(#Toolbar_TabLayout_Image_multibox))
  ToolBarImageButton(#Toolbar_TabLayout_singlebox,ImageID(#Toolbar_TabLayout_Image_singlebox))
  ToolBarImageButton(#Toolbar_TabLayout_spacer,ImageID(#Toolbar_TabLayout_Image_spacer))
  ToolBarImageButton(#Toolbar_TabLayout_vbox,ImageID(#Toolbar_TabLayout_Image_vbox))
  ToolBarToolTip(6,#Toolbar_TabLayout_acursor, "acursor")
  ToolBarToolTip(6,#Toolbar_TabLayout_gridbox, "gridbox")
  ToolBarToolTip(6,#Toolbar_TabLayout_hbox, "hbox")
  ToolBarToolTip(6,#Toolbar_TabLayout_multibox, "multibox")
  ToolBarToolTip(6,#Toolbar_TabLayout_singlebox, "singlebox")
  ToolBarToolTip(6,#Toolbar_TabLayout_spacer, "spacer")
  ToolBarToolTip(6,#Toolbar_TabLayout_vbox, "vbox")
  CloseGadgetList()
  
  ; >Tab Additonal
  ;==============
  AddGadgetItem(#MainWindow_Panel, -1, "Additonal", 0, 3)
  containerTabAdditonal=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ; SetGadgetColor(containerTabMenus,#PB_Gadget_BackColor,$00ff00)
  hTB7=CreateToolBar(7, GadgetID(containerTabAdditonal))
  ;delete the upper line
  SendMessage_(hTB7,#TB_SETSTYLE,0,SendMessage_(hTB7,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB7, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB7, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB7, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB7, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB7, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabAdditional_acursor,ImageID(#Toolbar_TabAdditional_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabAdditional_mdi,ImageID(#Toolbar_TabAdditional_Image_mdi))
  ToolBarImageButton(#Toolbar_TabAdditional_scintilla,ImageID(#Toolbar_TabAdditional_Image_scintilla))
  ToolBarImageButton(#Toolbar_TabAdditional_statusbar,ImageID(#Toolbar_TabAdditional_Image_statusbar))
  ToolBarImageButton(#Toolbar_TabAdditional_systray,ImageID(#Toolbar_TabAdditional_Image_systray))
  ToolBarImageButton(#Toolbar_TabAdditional_timer,ImageID(#Toolbar_TabAdditional_Image_timer))
  ToolBarImageButton(#Toolbar_TabAdditional_xml,ImageID(#Toolbar_TabAdditional_Image_xml))
  ToolBarToolTip(7,#Toolbar_TabAdditional_acursor, "acursor")
  ToolBarToolTip(7,#Toolbar_TabAdditional_mdi, "MDI")
  ToolBarToolTip(7,#Toolbar_TabAdditional_scintilla, "scintilla")
  ToolBarToolTip(7,#Toolbar_TabAdditional_statusbar, "statusbar")
  ToolBarToolTip(7,#Toolbar_TabAdditional_systray, "systray")
  ToolBarToolTip(7,#Toolbar_TabAdditional_timer, "timer")
  ToolBarToolTip(7,#Toolbar_TabAdditional_xml, "xml")
  CloseGadgetList()
  
  ; >Tab Custom
  ;==============
  AddGadgetItem(#MainWindow_Panel, -1, "Custom", 0, 4)
  containerTabCustom=ContainerGadget(#PB_Any, 0, 0, 610, ButtonIconHeight+ButtonIconMargin)
  ;SetGadgetColor(containerTabCustom,#PB_Gadget_BackColor,$00ff00)
  hTB8=CreateToolBar(8, GadgetID(containerTabCustom))
  ;delete the upper line
  SendMessage_(hTB8,#TB_SETSTYLE,0,SendMessage_(hTB8,#TB_GETSTYLE,0,0)|#CCS_NODIVIDER) 
  ;create dimensions of the imagelist 
  hOldIList = SendMessage_(hTB8, #TB_GETIMAGELIST, 0, 0);
  hNewIList = ImageList_Duplicate_(hOldIList)
  ImageList_Destroy_(hOldIList)
  ImageList_SetIconSize_(hNewIList, IconWidth, IconHeight)
  SendMessage_(hTB8, #TB_SETIMAGELIST, 0, hNewIList)
  ;Change the dimensions of the bitmap area of the imagelist
  SendMessage_(hTB8, #TB_SETBITMAPSIZE, 0, IconWidth|IconHeight<<16)
  ;Change the dimensions of buttons
  ButtonIconWidth=PanelClientHeight
  ButtonIconHeight=PanelClientHeight-6
  SendMessage_(hTB8, #TB_SETBUTTONSIZE, 0, ButtonIconWidth|ButtonIconHeight<<16)
  SendMessage_(hTB8, #TB_AUTOSIZE, 0, 0)
  ;Add icons in the toolbar
  ToolBarImageButton(#Toolbar_TabCustom_acursor,ImageID(#Toolbar_TabCustom_Image_acursor),#PB_ToolBar_Toggle)
  ToolBarImageButton(#Toolbar_TabCustom_shape,ImageID(#Toolbar_TabCustom_Image_shape))
  ToolBarToolTip(8,#Toolbar_TabCustom_acursor, "acursor")
  ToolBarToolTip(8,#Toolbar_TabCustom_shape, "shape")
  CloseGadgetList()
  
  ;Resize Gadgets (Note: Resize TopWindow
  ;Resize Panel
  ToolBarsLength = GadgetWidth(containerTB0)
  tmp=GadgetWidth(containerTB1)
  If tmp>ToolBarsLength:ToolBarsLength= tmp:EndIf 
  Margin = 5
  ResizeGadget(#MainWindow_Panel,#PB_Ignore,#PB_Ignore,DesktopWidth-ToolBarsLength-Margin,#PB_Ignore)
  ;Resize all containers and buttons of the panel
  Margin = 8
  ResizeGadget(containerTabStandard,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-ButtonPlusMinusWidth-Margin,#PB_Ignore)
  ResizeGadget(#WinMain_Panel_Container_GadgetStandard_ButtonPlus,DesktopWidth-ToolBarsLength-ButtonPlusMinusWidth-Margin,#PB_Ignore, #PB_Ignore,#PB_Ignore)
  ResizeGadget(#WinMain_Panel_Container_GadgetStandard_ButtonMinus,DesktopWidth-ToolBarsLength-ButtonPlusMinusWidth-Margin,#PB_Ignore, #PB_Ignore,#PB_Ignore)
  ResizeGadget(containerTabMenus,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore)
  ResizeGadget(containerTabContainer,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore)
  ResizeGadget(containerTabExplorer,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore)
  ResizeGadget(containerTabLayout,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore) 
  ResizeGadget(containerTabAdditonal,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore) 
  ResizeGadget(containerTabCustom,#PB_Ignore,#PB_Ignore, DesktopWidth-ToolBarsLength-Margin,#PB_Ignore) 
  ;Resize TopWindow
  TopWindowHeight=GetSystemMetrics_(#SM_CYCAPTION)+MenuHeight()+MainWindowClientHeight+GetSystemMetrics_(#SM_CYBORDER)*2 
  TopWindowHeight=TopWindowHeight-30 ; why do i minus 30 ? It's mysterious, a bug ?
  
  ResizeWindow(#Window_Main,#PB_Ignore,#PB_Ignore,#PB_Ignore,TopWindowHeight) 
  ;}
  
EndProcedure
;}

;- --- [NE] Window List of Forms ------------------------------------------------------
;{ [WINDOW LISTFORM] Enumeration
Enumeration Windows
  #FormList_Window
EndEnumeration

Enumeration Gadgets
  #FormList_ListIcon
EndEnumeration

Enumeration ToolBars
  #FormList_Toolbar_AddForm=#MenuItem_File_New
  #FormList_Toolbar_DeleteForm=#MenuItem_File_Close_Form
EndEnumeration

Enumeration ToolBars_Images
  #Img_FormList_Toolbar_AddForm
  #Img_FormList_Toolbar_DeleteForm
  #Img_FormList_Form
EndEnumeration
;}
;{ [WINDOW LISTFORM] LoadImage for ToolBars
LoadImage(#Img_FormList_Toolbar_AddForm,IconPath$ + "icons\FormListToolBar\application_add.png")
LoadImage(#Img_FormList_Toolbar_DeleteForm,IconPath$ + "icons\FormListToolBar\application_delete.png")
LoadImage(#Img_FormList_Form,IconPath$ + "icons\FormListToolBar\application.png")
;}
;{ [WINDOW LISTFORM] Global
Global Window_ListForm_ToolBar
Global PopUpMenu_Window_ListForm;PopUpMenu_Window_ListForm
                                ;}
;{ [WINDOW LISTFORM] Declare 
Procedure ResizeGadgets_Window_ListForm()
  Protected FormWindowWidth, FormWindowHeight
  FormWindowWidth = WindowWidth(#FormList_Window)
  FormWindowHeight = WindowHeight(#FormList_Window)
  ResizeGadget(#FormList_ListIcon, 0, 0, FormWindowWidth - 0, FormWindowHeight - 0)
  ResizeGadget(#FormList_ListIcon, 0, ToolBarHeight(Window_ListForm_ToolBar) + 0, FormWindowWidth - 0, FormWindowHeight - ToolBarHeight(Window_ListForm_ToolBar) - 0)
EndProcedure
;}
;{ [WINDOW LISTFORM] Procedures
Procedure OpenWindow_ListForm(x = 825, y = 140, width = 190, height = 160)
  OpenWindow(#FormList_Window, x, y, width, height, "Form List", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_Tool)
  ;ToolBar
  Window_ListForm_ToolBar=CreateToolBar(#PB_Any, WindowID(#FormList_Window))
  ToolBarImageButton(#FormList_Toolbar_AddForm,ImageID(#Img_FormList_Toolbar_AddForm))
  ToolBarToolTip(Window_ListForm_ToolBar, #FormList_Toolbar_AddForm, "Add Form")
  ToolBarImageButton(#FormList_Toolbar_DeleteForm,ImageID(#Img_FormList_Toolbar_DeleteForm))
  ToolBarToolTip(Window_ListForm_ToolBar, #FormList_Toolbar_DeleteForm, "Delete Form")
  ;PopUp Menu
  PopUpMenu_Window_ListForm=CreatePopupImageMenu(#PB_Any, #PB_Menu_ModernLook)
  MenuItem(#MenuItem_File_Close_Form, "Close Form" + Chr(9) + "Ctrl+Q")
  MenuBar()
  MenuItem(#MenuItem_File_New, "New Form")
  ;ListIconGadget
  ListIconGadget(#FormList_ListIcon, 0, ToolBarHeight(Window_ListForm_ToolBar) + 0, 190, 338, "Form", 100)
  AddGadgetColumn(#FormList_ListIcon, 1, "Path", 100)
  AddGadgetItem(#FormList_ListIcon, -1, "Form1", ImageID(#Img_FormList_Form))
EndProcedure
;}

;- --- [NW] Window Gadget Treeview -----------------------------------------------
;{ [WINDOW GADGETS_TREEVIEW] Enumeration
Enumeration Windows
  #Window_GadgetsTreeView
EndEnumeration

Enumeration Gadgets
  #Window_GadgetsTreeView_Tree
EndEnumeration

Enumeration ToolBars_Images
  #Img_Window_GadgetsTreeView_Form
EndEnumeration
;}
;{ [WINDOW GADGETS_TREEVIEW] LoadImage for ToolBars
LoadImage(#Img_Window_GadgetsTreeView_Form,IconPath$ + "icons\gadgets\application.png") ;16x16
                                                                                        ;}                                                                                        ;}
;{ [WINDOW GADGETS_TREEVIEW] Global                                                                                        ;{ [WINDOW GADGETS_TREEVIEW] Global 
Global PopUpMenu_Window_GadgetsTreeView
;}
;{ [WINDOW GADGETS_TREEVIEW] Declare 
Declare ResizeGadgets_Window_GadgetsTreeView()
;}
;{ [WINDOW GADGETS_TREEVIEW] Procedures
Procedure OpenWindow_GadgetsTreeView(x = 0, y = 140, width = 200, height = 210)
  OpenWindow(#Window_GadgetsTreeView, x, y, width, height, "Objects TreeView", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_Tool)
  ;PopUp Menu
  PopUpMenu_Window_GadgetsTreeView=CreatePopupImageMenu(#PB_Any, #PB_Menu_ModernLook)
  MenuItem(#MenuItem_Edit_Cut, "Cu&t" + Chr(9) + "Ctrl+X")
  MenuItem(#MenuItem_Edit_Copy, "&Copy" + Chr(9) + "Ctrl+C")
  MenuItem(#MenuItem_Edit_Paste, "&Paste" + Chr(9) + "Ctrl+V")
  MenuBar()
  MenuItem(#MenuItem_Delete, "&Delete")
  MenuBar()
  MenuItem(#MenuItem_Edit_SelectAll, "Select &All" + Chr(9) + "Ctrl+A")
  MenuItem(#MenuItem_Edit_TabOrder, "Tab &Order" + Chr(9) + "Ctrl+T")
  OpenSubMenu("&Gadget")
  MenuItem(#MenuItem_Edit_Gadget_Bringtofront, "Bring to front")
  MenuItem(#MenuItem_Edit_Gadget_Sendtoback, "Send to back")
  MenuBar()
  MenuItem(#MenuItem_Edit_Gadget_Lock, "Lock")
  MenuItem(#MenuItem_Edit_Gadget_Unlock, "Unlock")
  MenuItem(#MenuItem_Edit_Gadget_Noinsertin, "No insert in")
  MenuItem(#MenuItem_Edit_Gadget_Nocopy, "No copy")
  CloseSubMenu()
  OpenSubMenu("Align")
  MenuItem(#MenuItem_Edit_Align_Left, "Left")
  MenuItem(#MenuItem_Edit_Align_Center, "Center")
  MenuItem(#MenuItem_Edit_Align_Right, "Right")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_Top, "Top")
  MenuItem(#MenuItem_Edit_Align_Middle, "Middle")
  MenuItem(#MenuItem_Edit_Align_Bottom, "Bottom")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_SpaceEquallyHorizontally, "Space Equally Horizontally")
  MenuItem(#MenuItem_Edit_Align_SpaceEquallyVertically, "Space Equally Vertically")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_CenterHorizontallyInWindow, "Center Horizontally In Window")
  MenuItem(#MenuItem_Edit_Align_CenterVerticallyInWindow, "Center Vertically In Window")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_EqualWidth, "Equal Width")
  MenuItem(#MenuItem_Edit_Align_EqualHeight, "Equal Height")
  MenuItem(#MenuItem_Edit_Align_EqualSizeht, "Equal Size")
  MenuBar()
  MenuItem(#MenuItem_Edit_Align_ToGrid, "Align To Grid")
  CloseSubMenu()
  
  ;TreeGadget
  TreeGadget(#Window_GadgetsTreeView_Tree, 0, 0, 200, 210, #PB_Tree_AlwaysShowSelection)
  ;remove treebox
  SetWindowLong_(GadgetID(#Window_GadgetsTreeView_Tree), #GWL_STYLE, GetWindowLong_(GadgetID(#Window_GadgetsTreeView_Tree), #GWL_STYLE) & (~#TVS_LINESATROOT))
  ;add the first entry
  AddGadgetItem(#Window_GadgetsTreeView_Tree, -1, "Form1",ImageID(#Img_Window_GadgetsTreeView_Form))
EndProcedure
Procedure ResizeGadgets_Window_GadgetsTreeView()
  Protected FormWindowWidth, FormWindowHeight
  FormWindowWidth = WindowWidth(#Window_GadgetsTreeView)
  FormWindowHeight = WindowHeight(#Window_GadgetsTreeView)
  ResizeGadget(#Window_GadgetsTreeView_Tree, 0, 0, FormWindowWidth - 0, FormWindowHeight - 0)
EndProcedure
;}

;- --- [SW] Window Inspector -----------------------------------------------------
;{ [WINDOW INSPECTOR] Enumeration
Enumeration Windows
  #Window_Inspector
EndEnumeration

Enumeration Gadgets
  #Window_Inspector_ComboForm
  #Window_Inspector_Panel
  ;Tab Properties
  #Window_Inspector_Properties_ScrollArea
  #Window_Inspector_Properties_ContainerLeft
  #Window_Inspector_Properties_ContainerRight
  #Window_Inspector_Properties_Splitter
  ;Tab Event
  #Window_Inspector_Events_ScrollArea
  #Window_Inspector_Events_ContainerLeft
  #Window_Inspector_Events_ContainerRight
  #Window_Inspector_Events_Splitter
  ;Tab Api
  #Window_Inspector_Api_ScrollArea
  #Window_Inspector_Api_ContainerLeft
  #Window_Inspector_Api_ContainerRight
  #Window_Inspector_Api_Splitter
EndEnumeration

Enumeration ToolBars_Images
  #Img_Window_Inspector_ComboForm
EndEnumeration

; Enumeration FormFont
;   #Font_Window_Inspector_0
; EndEnumeration
; 
; LoadFont(#Font_Window_Inspector_0,"Arial", 9)
;}
;{ [WINDOW INSPECTOR] Global 
Global PrefPath$ ; Path to preference files
Global hWindow_Inspector_Panel 
;Global scaleDPI.f
Structure structureProperties
  KeyName.s
  KeyValue.s
EndStructure
Global NewList FormProperties.structureProperties()
Global NewList FormEvents.structureProperties()
Global NewList FormApi.structureProperties()
; In the window inspector, a "line" is made with 3 gadgets
Structure structureGadgetProperties
  NumberLine.l    ; Number of the line
  TypeLine.l      ; Type of the line -1="-", 0="+", 1="button"
  IDFirstGadget.l ; Id of the gadget 1
  IDKeyGadget.l   ; Id of the gadget 2
  IDValueGadget.l ; Id of the gadget 3
EndStructure
Global NewList Window_Inspector_GadgetsProperties.structureGadgetProperties()
Global NewList Window_Inspector_GadgetsEvents.structureGadgetProperties()
Global NewList Window_Inspector_GadgetsApi.structureGadgetProperties()
Global Window_Inspector_Properties_Splitter_Position
Global LittleButtonWidth=12 ;; I decide that the LittleButtons width will be 12 pixels 

;}
;{ [WINDOW INSPECTOR] LoadImage for ToolBars
LoadImage(#Img_Window_Inspector_ComboForm,IconPath$ + "icons\gadgets\application.png") ;16x16
                                                                                       ;}
;{ [WINDOW INSPECTOR] Declare 
Declare ResizeGadgets_Window_Inspector()
;}
;{ [WINDOW INSPECTOR] Procedures
Procedure.i GetDpiX()
  ;Get the DPI. 96 or more. Needed to fit gadgets with text
  Protected hdc.i
  Protected hDpi.i
  hdc = GetDC_(GetDesktopWindow_())
  If hdc
    hDpi = GetDeviceCaps_(hdc, #LOGPIXELSX)
    ReleaseDC_(GetDesktopWindow_(), hdc)
  EndIf
  ProcedureReturn hDpi
EndProcedure
;scaleDPI = 96/GetDpiX()
Procedure CaptionWidth(text$, font=-1, margin=0)
  ;font=-1 => Font sytem
  ;Get Text width, needed to fit gadgets with text
  
  Protected W
  
  If CreateImage(0, 200,200)
    StartDrawing(ImageOutput(0))
    If font <> -1 
      DrawingFont(font)
    EndIf
    W=TextWidth(text$) + margin
    StopDrawing()
  Else
    Debug "Error in CaptionWidth()"
    End
  EndIf
  FreeImage(0)
  ProcedureReturn W
EndProcedure
Procedure CaptionHeight(text$, font=-1, margin=0)
  ;font=-1 => Font sytem
  ;Get Text height, needed to fit gadgets with text
  
  Protected H
  
  If CreateImage(0, 200,200)
    StartDrawing(ImageOutput(0))
    If font <> -1 
      DrawingFont(font)
    EndIf
    H=TextHeight(text$) + margin
    StopDrawing()
  Else
    Debug "Error in CaptionHeight()"
    End
  EndIf
  FreeImage(0)
  ProcedureReturn H
EndProcedure
Procedure OpenWindow_Inspector(x = 0, y = 385, width = 200, height = 355)
  Protected tmp, LenMaxKeyName, BiggerKeyName$, LenMaxKeyValue, BiggerKeyValue$
  Protected NbPlus, tmpW, tmpHgadget, tmpWgadget, tmpHProperties, NumberOfProperties, yy, n, p, tmp$
  Protected nbItem, i, tmpHEvents, tmpHApi, SeparatorWidth
  
  OpenWindow(#Window_Inspector, x, y, width, height, "Objects Inspector", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_Tool)
  
  ;>>ComboBoxGadget, displaying the window or the gadget wich has the focus
  ComboBoxGadget(#Window_Inspector_ComboForm, 0, 0, 200, 30,#PB_ComboBox_Image)
  AddGadgetItem(#Window_Inspector_ComboForm, -1, "Form1")
  SetGadgetText(#Window_Inspector_ComboForm, "Form1")
  ;TODO icon should be different with a console appli, etc...
  SetGadgetItemImage(#Window_Inspector_ComboForm, 0, ImageID(#Img_Window_Inspector_ComboForm))
  
  ;>>PanelGadget: with 3 Tabs -> Tab Properties, Tab Events, Tab Api
  hWindow_Inspector_Panel=PanelGadget(#Window_Inspector_Panel, 0, 30, 200, 320)
  
  ;>Tab Properties
  AddGadgetItem(#Window_Inspector_Panel, -1, "Properties")
  ;ScrollAreaGadget
  ScrollAreaGadget(#Window_Inspector_Properties_ScrollArea, 0, 0, 197, 295, 170, 1300, 1)
  ContainerGadget(#Window_Inspector_Properties_ContainerLeft, 0, 0, 88, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Properties_ContainerLeft, #PB_Gadget_BackColor,RGB(255,128,128))
  ;SetGadgetFont(#Window_Inspector_Properties_ContainerLeft_Button_Caption, FontID(#Font_Window_Inspector_0))
  CloseGadgetList()
  ContainerGadget(#Window_Inspector_Properties_ContainerRight, 90, 0, 80, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Properties_ContainerRight, #PB_Gadget_BackColor,RGB(255,255,128))
  CloseGadgetList()
  ;Splitter vertical
  SplitterGadget(#Window_Inspector_Properties_Splitter, 0, 0, 168, 1300, #Window_Inspector_Properties_ContainerLeft, #Window_Inspector_Properties_ContainerRight, #PB_Splitter_Vertical);|#PB_Splitter_FirstFixed
  SetGadgetAttribute(#Window_Inspector_Properties_Splitter, #PB_Splitter_FirstMinimumSize, 20)
  SetGadgetAttribute(#Window_Inspector_Properties_Splitter, #PB_Splitter_SecondMinimumSize, 20)  
  CloseGadgetList();scrollarea  
  
  ;>Tab Events
  AddGadgetItem(#Window_Inspector_Panel, -1, "Events", 0, 1)
  ;ScrollAreaGadget
  ScrollAreaGadget(#Window_Inspector_Events_ScrollArea, 0, 0, 197, 295, 170, 1300, 1)
  ContainerGadget(#Window_Inspector_Events_ContainerLeft, 0, 0, 88, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Events_ContainerLeft, #PB_Gadget_BackColor,RGB(255,128,128))
  ; SetGadgetFont(#Window_Inspector_Events_ContainerLeft_Button_Caption, FontID(#Font_Window_Inspector_0))
  CloseGadgetList()
  ContainerGadget(#Window_Inspector_Events_ContainerRight, 90, 0, 80, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Events_ContainerRight, #PB_Gadget_BackColor,RGB(255,255,128))
  CloseGadgetList()
  ;Splitter vertical
  SplitterGadget(#Window_Inspector_Events_Splitter, 0, 0, 168, 1300, #Window_Inspector_Events_ContainerLeft, #Window_Inspector_Events_ContainerRight, #PB_Splitter_Vertical|#PB_Splitter_FirstFixed)
  SetGadgetAttribute(#Window_Inspector_Events_Splitter, #PB_Splitter_FirstMinimumSize, 20)
  SetGadgetAttribute(#Window_Inspector_Events_Splitter, #PB_Splitter_SecondMinimumSize, 20)  
  CloseGadgetList();scrollarea 
  
  ;>Tab Api
  AddGadgetItem(#Window_Inspector_Panel, -1, "Api", 0, 2)
  ;ScrollAreaGadget
  ScrollAreaGadget(#Window_Inspector_Api_ScrollArea, 0, 0, 197, 295, 170, 1300, 1)
  ContainerGadget(#Window_Inspector_Api_ContainerLeft, 0, 0, 88, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Api_ContainerLeft, #PB_Gadget_BackColor,RGB(255,128,128))
  ; SetGadgetFont(#Window_Inspector_Api_ContainerLeft_Button_Caption, FontID(#Font_Window_Inspector_0))
  CloseGadgetList()
  ContainerGadget(#Window_Inspector_Api_ContainerRight, 90, 0, 80, 1300, #PB_Container_BorderLess)
  ;SetGadgetColor(#Window_Inspector_Api_ContainerRight, #PB_Gadget_BackColor,RGB(255,255,128))
  CloseGadgetList()
  ;Splitter vertical
  SplitterGadget(#Window_Inspector_Api_Splitter, 0, 0, 168, 1300, #Window_Inspector_Api_ContainerLeft, #Window_Inspector_Api_ContainerRight, #PB_Splitter_Vertical|#PB_Splitter_FirstFixed)
  SetGadgetAttribute(#Window_Inspector_Api_Splitter, #PB_Splitter_FirstMinimumSize, 20)
  SetGadgetAttribute(#Window_Inspector_Api_Splitter, #PB_Splitter_SecondMinimumSize, 20)  
  CloseGadgetList();scrollarea
  
  CloseGadgetList();panel
  
  ;Fill the panel with /Prefs/Windows/Form.txt
  ;{ TAB PROPERTIES Fill the left container 
  ; Open pref
  PrefPath$=GetCurrentDirectory()
  If OpenPreferences(PrefPath$ +"Prefs/Windows/Form.txt") = 0
    MessageRequester("Attention", "Prefs/Windows/Form.txt Missing !")
    End
  EndIf
  ; Open Group 'properties'
  If PreferenceGroup("properties") = 0
    MessageRequester("Attention", "Prefs/Windows/Form.txt Corrupted !")
    End
  EndIf
  ; Read 'properties' keys
  ExaminePreferenceKeys()
  While  NextPreferenceKey() 
    AddElement(FormProperties())
    FormProperties()\KeyName= PreferenceKeyName()
    FormProperties()\KeyValue= PreferenceKeyValue()  
    ; Find the largest text 
    tmp=Len(FormProperties()\KeyName)
    If tmp>LenMaxKeyName
      LenMaxKeyName=tmp 
      BiggerKeyName$=FormProperties()\KeyName
    EndIf
    tmp=Len(FormProperties()\KeyValue)
    If tmp>LenMaxKeyValue
      LenMaxKeyValue=tmp  
      BiggerKeyValue$=FormProperties()\KeyValue
    EndIf
    If FormProperties()\KeyName ="+"
      NbPlus + 1
    EndIf
  Wend
  
  ; Compute size of future gadgets, in pixels (to Fit gadgets with text size)
  tmpHgadget=CaptionHeight("Wg", -1, 0)
  tmpWgadget=CaptionWidth(BiggerKeyName$,-1,-10); -10 = margin
  tmpHProperties=(ListSize(FormProperties())-NbPlus)*tmpHgadget
  tmpW=GadgetWidth(#Window_Inspector_Properties_ContainerLeft)
  
  ; Resize ScrollArea, containers and move the splitter (necessary ?)
  tmp=90 ; I decide that the rigth panel width will be 90 pixels
  SeparatorWidth=GetSystemMetrics_(#SM_CXSIZEFRAME); i hope the width of the splittergadget separator is GetSystemMetrics_(#SM_CXSIZEFRAME)
  ;LittleButtonWidth=12 ; I decide that the LittleButtons width will be 12 pixels 
  SetGadgetAttribute(#Window_Inspector_Properties_ScrollArea,#PB_ScrollArea_InnerWidth, LittleButtonWidth+tmpWgadget+tmp+SeparatorWidth)
  SetGadgetAttribute(#Window_Inspector_Properties_ScrollArea, #PB_ScrollArea_InnerHeight,tmpHProperties)
  ResizeGadget(#Window_Inspector_Properties_ContainerLeft, #PB_Ignore, #PB_Ignore, LittleButtonWidth+tmpWgadget, tmpHProperties)
  ResizeGadget(#Window_Inspector_Properties_ContainerRight, #PB_Ignore, #PB_Ignore, tmp, tmpHProperties)
  SetGadgetState(#Window_Inspector_Properties_Splitter, LittleButtonWidth+tmpWgadget)
  
  ; Number of properties + number of "-" (= number of lines displayed)
  ; NumberOfProperties = ListSize(FormProperties()) - NbPlus
  ; TODO replace buttons "+" and buttons "-" by a tree 
  
  ; Fill the left container with a little button (12 pixels width) and a button with a keyname or a "-"
  yy=0  ; coordonnate Y = Top of each gadget
  n=1   ; count lines
  tmpWgadget=tmp
  
  ResetList(FormProperties())
  OpenGadgetList(#Window_Inspector_Properties_ContainerLeft)

  While NextElement(FormProperties())
    AddElement(Window_Inspector_GadgetsProperties())
    Window_Inspector_GadgetsProperties()\NumberLine=n
    
    ;button "-"
    If FormProperties()\KeyName ="-"
      Window_Inspector_GadgetsProperties()\TypeLine=-1
      p=TextGadget(#PB_Any,0,yy,12,tmpHgadget,"-",#PB_Text_Center) ; The little button
      DisableGadget(p, #True)
      Window_Inspector_GadgetsProperties()\IDFirstGadget=p
      p=TextGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormProperties()\KeyName,#PB_Text_Center)
      DisableGadget(p, #True)
      Window_Inspector_GadgetsProperties()\IDKeyGadget=p
      
      ;button "+" 
    ElseIf FormProperties()\KeyName ="+"
      Window_Inspector_GadgetsProperties()\TypeLine=0  
      Window_Inspector_GadgetsProperties()\IDFirstGadget=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"+"); The little button
      NextElement(FormProperties())    
      Window_Inspector_GadgetsProperties()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormProperties()\KeyName,#PB_Button_Left |#PB_Button_Toggle)    
      
      ;button "abc"
    Else
      Window_Inspector_GadgetsProperties()\TypeLine=1
      p=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"")
      DisableGadget(p, #True) 
      Window_Inspector_GadgetsProperties()\IDFirstGadget=p  
      Window_Inspector_GadgetsProperties()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormProperties()\KeyName,#PB_Button_Left |#PB_Button_Toggle)
      
    EndIf
    yy+tmpHgadget 
    n+1
  Wend   
  CloseGadgetList();#Window_Inspector_Properties_ContainerLeft
  
  ;>>Right Container
  ;resize
  ;   tmpWgadget+20
  ;   ResizeGadget(#Window_Inspector_Properties_ContainerRight, #PB_Ignore, #PB_Ignore, tmpWgadget,#PB_Ignore)
  
  yy=0
  ;n=0
  ResetList(FormProperties()) 
  ResetList(Window_Inspector_GadgetsProperties())
  OpenGadgetList(#Window_Inspector_Properties_ContainerRight)
  
  While NextElement(FormProperties())
    ;n+1
    NextElement(Window_Inspector_GadgetsProperties()) 
    
    tmp$=FormProperties()\KeyValue
    
    If  tmp$="+";FormProperties()\KeyValue
      NextElement(FormProperties())
      tmp$=FormProperties()\KeyValue
      ; Window_Inspector_GadgetsProperties()\Value=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf  
    If tmp$="-"
      p=TextGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"-",#PB_Text_Center)
      DisableGadget(p,#True)
      Window_Inspector_GadgetsProperties()\IdValueGadget=p
      ;        NextElement(FormProperties())
      ;        tmp$=FormProperties()\KeyValue
      
      ;checkbox = yes|no
      ;combobox = #True|#False
      ;buton = ()
      ;combobox = ..., ...,     
      ;editbox = 'else'
    ElseIf LCase(tmp$) = "yes"
      Window_Inspector_GadgetsProperties()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
      SetGadgetState(Window_Inspector_GadgetsProperties()\IdValueGadget,#PB_Checkbox_Checked )
    ElseIf LCase(tmp$) = "no"
      Window_Inspector_GadgetsProperties()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
    ElseIf  LCase(tmp$) = "#true" 
      Window_Inspector_GadgetsProperties()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsProperties()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsProperties()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsProperties()\IdValueGadget,0)
    ElseIf  LCase(tmp$) = "#false"
      Window_Inspector_GadgetsProperties()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsProperties()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsProperties()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsProperties()\IdValueGadget,0)
    ElseIf FindString(tmp$,"(")
      Window_Inspector_GadgetsProperties()\IdValueGadget=ButtonGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$,#PB_Button_Left)
    ElseIf FindString(tmp$,",")
      nbItem = CountString(tmp$,",")
      Window_Inspector_GadgetsProperties()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      For i= 1 To nbItem
        AddGadgetItem(Window_Inspector_GadgetsProperties()\IdValueGadget, -1, StringField(tmp$, nbItem, ","))
      Next i
      SetGadgetState(Window_Inspector_GadgetsProperties()\IdValueGadget,0)
    Else
      Window_Inspector_GadgetsProperties()\IdValueGadget=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf 
    
    yy+tmpHgadget 
  Wend   
  CloseGadgetList();#Window_Inspector_Properties_ContainerRight
  
  ;resize containers
  ; tmpWgadget+20
  ResizeGadget(#Window_Inspector_Properties_ContainerLeft, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  ResizeGadget(#Window_Inspector_Properties_ContainerRight, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  
  
  
  ;   Debug ListSize(Window_Inspector_GadgetsProperties())
  ;   Debug "----"
  ;   ForEach Window_Inspector_GadgetsProperties()
  ;     Debug  Window_Inspector_GadgetsProperties()\NumberLine
  ;     Debug  Window_Inspector_GadgetsProperties()\TypeLine
  ;     Debug  Window_Inspector_GadgetsProperties()\IDFirstGadget
  ;     Debug  Window_Inspector_GadgetsProperties()\IDKeyGadget
  ;     Debug  Window_Inspector_GadgetsProperties()\IdValueGadget
  ;     Debug "====="
  ;   Next
  ;}
   ;{ TAB EVENTS Fill the left container 
    LenMaxKeyName=0
    NbPlus=0
    ; Open Group 'events'
    If PreferenceGroup("events") = 0
      MessageRequester("Attention", "Prefs/Windows/Form.txt Corrupted !")
      End
    EndIf
    ; Read 'events' keys
    ExaminePreferenceKeys()
    While  NextPreferenceKey() 
      AddElement(FormEvents())
      FormEvents()\KeyName= PreferenceKeyName()
      FormEvents()\KeyValue= PreferenceKeyValue()  
      
      tmp=Len(FormEvents()\KeyName)
      If tmp>LenMaxKeyName
        LenMaxKeyName=tmp 
        BiggerKeyName$=FormEvents()\KeyName
      EndIf
      tmp=Len(FormEvents()\KeyValue)
      If tmp>LenMaxKeyValue
        LenMaxKeyValue=tmp  
        BiggerKeyValue$=FormEvents()\KeyValue
      EndIf
      If FormEvents()\KeyName ="+"
        NbPlus + 1
      EndIf
    Wend
    ;Debug BiggerKeyName$
   
  ; Compute size of future gadgets, in pixels (to Fit gadgets with text size)
  ;tmpHgadget=CaptionHeight("Wg", -1, 0)  
    tmpWgadget=CaptionWidth(BiggerKeyName$,-1,-0); -10: margin
    ;Debug tmpWgadget
  tmpHEvents=(ListSize(FormEvents())-NbPlus)*tmpHgadget
  tmpW=GadgetWidth(#Window_Inspector_Events_ContainerLeft)
    
  ; Resize ScrollArea, containers and move the splitter (necessary ?)
    tmp=90 ; I decide that the rigth panel width will be 90 pixels
  ;SeparatorWidth=GetSystemMetrics_(#SM_CXSIZEFRAME); i hope the width of the splittergadget separator is GetSystemMetrics_(#SM_CXSIZEFRAME)
  ;LittleButtonWidth=12 ; I decide that the LittleButtons width will be 12 pixels
  SetGadgetAttribute(#Window_Inspector_Events_ScrollArea,#PB_ScrollArea_InnerWidth, LittleButtonWidth+tmpWgadget+tmp+SeparatorWidth)
  SetGadgetAttribute(#Window_Inspector_Events_ScrollArea, #PB_ScrollArea_InnerHeight,tmpHEvents)
  ResizeGadget(#Window_Inspector_Events_ContainerLeft, #PB_Ignore, #PB_Ignore, LittleButtonWidth+tmpWgadget, tmpHEvents)
  ResizeGadget(#Window_Inspector_Events_ContainerRight, #PB_Ignore, #PB_Ignore, tmp, tmpHEvents)
  SetGadgetState(#Window_Inspector_Events_Splitter, LittleButtonWidth+tmpWgadget)
 
  ; Number of Events + number of "-" (= number of lines displayed)
  ; NumberOfEvents = ListSize(FormPEvents()) - NbPlus
  ; TODO replace buttons "+" and buttons "-" by a tree 
  
  ; Fill the left container with a little button (12 pixels width) and a button with a keyname or a "-"
  yy=0  ; coordonnate Y = Top of each gadget
  n=1   ; count lines
 
  
  ResetList(FormEvents())
  OpenGadgetList(#Window_Inspector_Events_ContainerLeft)

  While NextElement(FormEvents())
    AddElement(Window_Inspector_GadgetsEvents())
    Window_Inspector_GadgetsEvents()\NumberLine=n
    
    ;button "-"
    If FormEvents()\KeyName ="-"
      Window_Inspector_GadgetsEvents()\TypeLine=-1
      p=TextGadget(#PB_Any,0,yy,12,tmpHgadget,"-",#PB_Text_Center) ; The little button
      DisableGadget(p, #True)
      Window_Inspector_GadgetsEvents()\IDFirstGadget=p
      p=TextGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormEvents()\KeyName,#PB_Text_Center)
      DisableGadget(p, #True)
      Window_Inspector_GadgetsEvents()\IDKeyGadget=p
      
      ;button "+" 
    ElseIf FormEvents()\KeyName ="+"
      Window_Inspector_GadgetsEvents()\TypeLine=0  
      Window_Inspector_GadgetsEvents()\IDFirstGadget=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"+"); The little button
      NextElement(FormEvents())    
      Window_Inspector_GadgetsEvents()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormEvents()\KeyName,#PB_Button_Left |#PB_Button_Toggle)    
      
      ;button "abc"
    Else
      Window_Inspector_GadgetsEvents()\TypeLine=1
      p=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"")
      DisableGadget(p, #True) 
      Window_Inspector_GadgetsEvents()\IDFirstGadget=p  
      Window_Inspector_GadgetsEvents()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormEvents()\KeyName,#PB_Button_Left |#PB_Button_Toggle)
      
    EndIf
    yy+tmpHgadget 
    n+1
  Wend   
  CloseGadgetList();#Window_Inspector_Events_ContainerLeft
  
  
    ;>>Right Container
  ;resize
  ;   tmpWgadget+20
  ;   ResizeGadget(#Window_Inspector_Events_ContainerRight, #PB_Ignore, #PB_Ignore, tmpWgadget,#PB_Ignore)
  
  yy=0
  ;n=0
  tmpWgadget=tmp

  ResetList(FormEvents()) 
  ResetList(Window_Inspector_GadgetsEvents())
  OpenGadgetList(#Window_Inspector_Events_ContainerRight)
  
  While NextElement(FormEvents())
    ;n+1
    NextElement(Window_Inspector_GadgetsEvents()) 
    
    tmp$=FormEvents()\KeyValue
    
    If  tmp$="+";FormEvents()\KeyValue
      NextElement(FormEvents())
      tmp$=FormEvents()\KeyValue
      ; Window_Inspector_GadgetsEvents()\Value=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf  
    If tmp$="-"
      p=TextGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"-",#PB_Text_Center)
      DisableGadget(p,#True)
      Window_Inspector_GadgetsEvents()\IdValueGadget=p
      ;        NextElement(FormEvents())
      ;        tmp$=FormEvents()\KeyValue
      
      ;checkbox = yes|no
      ;combobox = #True|#False
      ;buton = ()
      ;combobox = ..., ...,     
      ;editbox = 'else'
    ElseIf LCase(tmp$) = "yes"
      Window_Inspector_GadgetsEvents()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
      SetGadgetState(Window_Inspector_GadgetsEvents()\IdValueGadget,#PB_Checkbox_Checked )
    ElseIf LCase(tmp$) = "no"
      Window_Inspector_GadgetsEvents()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
    ElseIf  LCase(tmp$) = "#true" 
      Window_Inspector_GadgetsEvents()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsEvents()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsEvents()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsEvents()\IdValueGadget,0)
    ElseIf  LCase(tmp$) = "#false"
      Window_Inspector_GadgetsEvents()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsEvents()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsEvents()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsEvents()\IdValueGadget,0)
    ElseIf FindString(tmp$,"(")
      Window_Inspector_GadgetsEvents()\IdValueGadget=ButtonGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$,#PB_Button_Left)
    ElseIf FindString(tmp$,",")
      nbItem = CountString(tmp$,",")
      Window_Inspector_GadgetsEvents()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      For i= 1 To nbItem
        AddGadgetItem(Window_Inspector_GadgetsEvents()\IdValueGadget, -1, StringField(tmp$, nbItem, ","))
      Next i
      SetGadgetState(Window_Inspector_GadgetsEvents()\IdValueGadget,0)
    Else
      Window_Inspector_GadgetsEvents()\IdValueGadget=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf 
    
    yy+tmpHgadget 
  Wend   
  CloseGadgetList();#Window_Inspector_Events_ContainerRight
  
  ;resize containers
  ; tmpWgadget+20
  ResizeGadget(#Window_Inspector_Events_ContainerLeft, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  ResizeGadget(#Window_Inspector_Events_ContainerRight, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  
 
  ;}
   ;{ TAB Api: Fill the left container 
    LenMaxKeyName=0
    NbPlus=0
    ; Open Group 'Api'
    If PreferenceGroup("Api") = 0
      MessageRequester("Attention", "Prefs/Windows/Form.txt Corrupted !")
      End
    EndIf
    ; Read 'Api' keys
    ExaminePreferenceKeys()
    While  NextPreferenceKey() 
      AddElement(FormApi())
      FormApi()\KeyName= PreferenceKeyName()
      FormApi()\KeyValue= PreferenceKeyValue()  
      
      tmp=Len(FormApi()\KeyName)
      If tmp>LenMaxKeyName
        LenMaxKeyName=tmp 
        BiggerKeyName$=FormApi()\KeyName
      EndIf
      tmp=Len(FormApi()\KeyValue)
      If tmp>LenMaxKeyValue
        LenMaxKeyValue=tmp  
        BiggerKeyValue$=FormApi()\KeyValue
      EndIf
      If FormApi()\KeyName ="+"
        NbPlus + 1
      EndIf
    Wend
    
 
    
     ; Compute size of future gadgets, in pixels (to Fit gadgets with text size)
     ;tmpHgadget=CaptionHeight("Wg", -1, 0)
      tmpWgadget=CaptionWidth(BiggerKeyName$,-1,-0); -0: margin
    tmpHApi=(ListSize(FormApi())-NbPlus)*tmpHgadget
    tmpW=GadgetWidth(#Window_Inspector_Api_ContainerLeft)

    ; Resize ScrollArea, containers and move the splitter (necessary ?)
  tmp=90 ; I decide that the rigth panel width will be 90 pixels
  ;SeparatorWidth=GetSystemMetrics_(#SM_CXSIZEFRAME); i hope the width of the splittergadget separator is GetSystemMetrics_(#SM_CXSIZEFRAME)
  ;LittleButtonWidth=12 ; I decide that the LittleButtons width will be 12 pixels
  SetGadgetAttribute(#Window_Inspector_Api_ScrollArea,#PB_ScrollArea_InnerWidth, LittleButtonWidth+tmpWgadget+tmp+SeparatorWidth)
  SetGadgetAttribute(#Window_Inspector_Api_ScrollArea, #PB_ScrollArea_InnerHeight,tmpHApi)
  ResizeGadget(#Window_Inspector_Api_ContainerLeft, #PB_Ignore, #PB_Ignore, LittleButtonWidth+tmpWgadget, tmpHApi)
  ResizeGadget(#Window_Inspector_Api_ContainerRight, #PB_Ignore, #PB_Ignore, tmp, tmpHApi)
  SetGadgetState(#Window_Inspector_Api_Splitter, LittleButtonWidth+tmpWgadget)
  
  ; Number of Api + number of "-" (= number of lines displayed)
  ; NumberOfApi = ListSize(FormApi()) - NbPlus
  ; TODO replace buttons "+" and buttons "-" by a tree 
  
  ; Fill the left container with a little button (12 pixels width) and a button with a keyname or a "-"
  yy=0  ; coordonnate Y = Top of each gadget
  n=1   ; count lines
  
  ResetList(FormApi())
  OpenGadgetList(#Window_Inspector_Api_ContainerLeft)

  While NextElement(FormApi())
    AddElement(Window_Inspector_GadgetsApi())
    Window_Inspector_GadgetsApi()\NumberLine=n
    
    ;button "-"
    If FormApi()\KeyName ="-"
      Window_Inspector_GadgetsApi()\TypeLine=-1
      p=TextGadget(#PB_Any,0,yy,12,tmpHgadget,"-",#PB_Text_Center) ; The little button
      DisableGadget(p, #True)
      Window_Inspector_GadgetsApi()\IDFirstGadget=p
      p=TextGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormApi()\KeyName,#PB_Text_Center)
      DisableGadget(p, #True)
      Window_Inspector_GadgetsApi()\IDKeyGadget=p
      
      ;button "+" 
    ElseIf FormApi()\KeyName ="+"
      Window_Inspector_GadgetsApi()\TypeLine=0  
      Window_Inspector_GadgetsApi()\IDFirstGadget=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"+"); The little button
      NextElement(FormApi())    
      Window_Inspector_GadgetsApi()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormApi()\KeyName,#PB_Button_Left |#PB_Button_Toggle)    
      
      ;button "abc"
    Else
      Window_Inspector_GadgetsApi()\TypeLine=1
      p=ButtonGadget(#PB_Any,0,yy,12,tmpHgadget,"")
      DisableGadget(p, #True) 
      Window_Inspector_GadgetsApi()\IDFirstGadget=p  
      Window_Inspector_GadgetsApi()\IDKeyGadget=ButtonGadget(#PB_Any,12,yy,tmpWgadget,tmpHgadget,FormApi()\KeyName,#PB_Button_Left |#PB_Button_Toggle)
      
    EndIf
    yy+tmpHgadget 
    n+1
  Wend   
  CloseGadgetList();#Window_Inspector_Api_ContainerLeft
  
  ;>>Right Container
  ;resize
  ;   tmpWgadget+20
  ;   ResizeGadget(#Window_Inspector_Api_ContainerRight, #PB_Ignore, #PB_Ignore, tmpWgadget,#PB_Ignore)
  
  yy=0
  ;n=0
  tmpWgadget=tmp
  
  ResetList(FormApi()) 
  ResetList(Window_Inspector_GadgetsApi())
  OpenGadgetList(#Window_Inspector_Api_ContainerRight)
  
  While NextElement(FormApi())
    ;n+1
    NextElement(Window_Inspector_GadgetsApi()) 
    
    tmp$=FormApi()\KeyValue
    
    If  tmp$="+";FormApi()\KeyValue
      NextElement(FormApi())
      tmp$=FormApi()\KeyValue
      ; Window_Inspector_GadgetsApi()\Value=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf  
    If tmp$="-"
      p=TextGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"-",#PB_Text_Center)
      DisableGadget(p,#True)
      Window_Inspector_GadgetsApi()\IdValueGadget=p
      ;        NextElement(FormApi())
      ;        tmp$=FormApi()\KeyValue
      
      ;checkbox = yes|no
      ;combobox = #True|#False
      ;buton = ()
      ;combobox = ..., ...,     
      ;editbox = 'else'
    ElseIf LCase(tmp$) = "yes"
      Window_Inspector_GadgetsApi()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
      SetGadgetState(Window_Inspector_GadgetsApi()\IdValueGadget,#PB_Checkbox_Checked )
    ElseIf LCase(tmp$) = "no"
      Window_Inspector_GadgetsApi()\IdValueGadget=CheckBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,"")
    ElseIf  LCase(tmp$) = "#true" 
      Window_Inspector_GadgetsApi()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsApi()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsApi()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsApi()\IdValueGadget,0)
    ElseIf  LCase(tmp$) = "#false"
      Window_Inspector_GadgetsApi()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      AddGadgetItem(Window_Inspector_GadgetsApi()\IdValueGadget, -1, "#True")
      AddGadgetItem(Window_Inspector_GadgetsApi()\IdValueGadget, -1, "#False")
      SetGadgetState(Window_Inspector_GadgetsApi()\IdValueGadget,0)
    ElseIf FindString(tmp$,"(")
      Window_Inspector_GadgetsApi()\IdValueGadget=ButtonGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$,#PB_Button_Left)
    ElseIf FindString(tmp$,",")
      nbItem = CountString(tmp$,",")
      Window_Inspector_GadgetsApi()\IdValueGadget=ComboBoxGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget)
      For i= 1 To nbItem
        AddGadgetItem(Window_Inspector_GadgetsApi()\IdValueGadget, -1, StringField(tmp$, nbItem, ","))
      Next i
      SetGadgetState(Window_Inspector_GadgetsApi()\IdValueGadget,0)
    Else
      Window_Inspector_GadgetsApi()\IdValueGadget=StringGadget(#PB_Any,0,yy,tmpWgadget,tmpHgadget,tmp$)
    EndIf 
    
    yy+tmpHgadget 
  Wend   
  CloseGadgetList();#Window_Inspector_Api_ContainerRight
  
  ;resize containers
  ; tmpWgadget+20
  ResizeGadget(#Window_Inspector_Api_ContainerLeft, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  ResizeGadget(#Window_Inspector_Api_ContainerRight, #PB_Ignore, #PB_Ignore, #PB_Ignore,yy)
  
;}
    
    ClosePreferences() 
    
  ;   ;resize tab properties
  ;   ResizeGadget(#Window_Inspector_Properties_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Properties_ContainerLeft)+GadgetWidth(#Window_Inspector_Properties_ContainerRight), #PB_Ignore)
  ;   SetGadgetAttribute(#Window_Inspector_Properties_ScrollArea, #PB_ScrollArea_InnerWidth, GadgetWidth(#Window_Inspector_Properties_ContainerLeft)+GadgetWidth(#Window_Inspector_Properties_ContainerRight))
  ;   SetGadgetAttribute(#Window_Inspector_Properties_ScrollArea, #PB_ScrollArea_InnerHeight, tmpHProperties)
  ;   ;resize tab events
  ;   ResizeGadget(#Window_Inspector_Events_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Properties_Splitter), #PB_Ignore)
  ;   SetGadgetAttribute(#Window_Inspector_Events_ScrollArea, #PB_ScrollArea_InnerWidth, GadgetWidth(#Window_Inspector_Events_ContainerLeft)+GadgetWidth(#Window_Inspector_Events_ContainerRight))
  ;   SetGadgetAttribute(#Window_Inspector_Events_ScrollArea, #PB_ScrollArea_InnerHeight, tmpHEvents)
  ;   ;resize tab Api
  ;   ResizeGadget(#Window_Inspector_Api_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Properties_Splitter), #PB_Ignore)
  ;   SetGadgetAttribute(#Window_Inspector_Api_ScrollArea, #PB_ScrollArea_InnerWidth, GadgetWidth(#Window_Inspector_Api_ContainerLeft)+GadgetWidth(#Window_Inspector_Api_ContainerRight))
  ;   SetGadgetAttribute(#Window_Inspector_Api_ScrollArea, #PB_ScrollArea_InnerHeight, tmpHApi)
  ;   
  ;   ;SetGadgetState(#Window_Inspector_Api_Splitter,12+tmpWgadget);
  ;   ;ResizeWindow(#Window_Inspector,#PB_Ignore,#PB_Ignore,GadgetWidth(#Window_Inspector_Properties_Splitter)+30,#PB_Ignore)
  ;   ;ResizeGadgets_Window_Inspector()
  ;   
  ;   ;   ForEach Window_Inspector_GadgetsProperties()
  ;   ;     Debug Window_Inspector_GadgetsProperties()\Number
  ;   ;     Debug Window_Inspector_GadgetsProperties()\Flag
  ;   ;     Debug Window_Inspector_GadgetsProperties()\Key
  ;   ;     Debug Window_Inspector_GadgetsProperties()\Value
  ;   ;     Debug "-------------"
  ;   ;   Next
EndProcedure
Procedure ResizeGadgets_Window_Inspector()
  Protected FormWindowWidth, FormWindowHeight
  Protected SplitterPosition
  
  FormWindowWidth = WindowWidth(#Window_Inspector)
  FormWindowHeight = WindowHeight(#Window_Inspector)
  ;   ResizeGadget(#Window_Inspector_ComboForm, 0, 0, FormWindowWidth - 0, 30)
  ;   ResizeGadget(#Window_Inspector_Panel, 0, 30, FormWindowWidth - 0, FormWindowHeight - 30)
  ;   ResizeGadget(#Window_Inspector_Properties_ScrollArea, 0, 0, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemWidth) - 3, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemHeight) - -2)
  ;   ResizeGadget(#Window_Inspector_Properties_Splitter, 0, 0, FormWindowWidth, FormWindowHeight)
  ResizeGadget(#Window_Inspector_ComboForm, 0, 0, FormWindowWidth - 0, #PB_Ignore)
  ResizeGadget(#Window_Inspector_Panel, 0, GadgetHeight(#Window_Inspector_ComboForm), FormWindowWidth - 0, FormWindowHeight - GadgetHeight(#Window_Inspector_ComboForm))
  ;tabs
  SplitterPosition=GetGadgetState(#Window_Inspector_Properties_Splitter) ; a bug ?
  ResizeGadget(#Window_Inspector_Properties_ScrollArea, 0, 0, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemWidth) - 3, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemHeight) -3) 
  SetGadgetAttribute(#Window_Inspector_Properties_ScrollArea, #PB_ScrollArea_InnerWidth, FormWindowWidth)
  ;ResizeGadget(#Window_Inspector_Properties_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Properties_ScrollArea)-GadgetWidth(#Window_Inspector_Properties_ContainerLeft), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Properties_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Properties_ScrollArea), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Properties_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Properties_ScrollArea)-GadgetWidth(#Window_Inspector_Properties_ContainerLeft), #PB_Ignore)
  SetGadgetState(#Window_Inspector_Properties_Splitter, SplitterPosition)
  
  SplitterPosition=GetGadgetState(#Window_Inspector_Events_Splitter)
  ResizeGadget(#Window_Inspector_Events_ScrollArea, 0, 0, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemWidth) - 3, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemHeight) -3) 
  SetGadgetAttribute(#Window_Inspector_Events_ScrollArea, #PB_ScrollArea_InnerWidth, FormWindowWidth)
  ;ResizeGadget(#Window_Inspector_Events_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Events_ScrollArea)-GadgetWidth(#Window_Inspector_Events_ContainerLeft), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Events_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Events_ScrollArea), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Events_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Events_ScrollArea)-GadgetWidth(#Window_Inspector_Events_ContainerLeft), #PB_Ignore)
  SetGadgetState(#Window_Inspector_Events_Splitter, SplitterPosition)
  
  SplitterPosition=GetGadgetState(#Window_Inspector_Api_Splitter)
  ResizeGadget(#Window_Inspector_Api_ScrollArea, 0, 0, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemWidth) - 3, GetGadgetAttribute(#Window_Inspector_Panel,#PB_Panel_ItemHeight) -3) 
  SetGadgetAttribute(#Window_Inspector_Api_ScrollArea, #PB_ScrollArea_InnerWidth, FormWindowWidth)
  ;ResizeGadget(#Window_Inspector_Api_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Api_ScrollArea)-GadgetWidth(#Window_Inspector_Api_ContainerLeft), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Api_Splitter, 0, 0, GadgetWidth(#Window_Inspector_Api_ScrollArea), #PB_Ignore)
  ResizeGadget(#Window_Inspector_Api_ContainerRight, #PB_Ignore, #PB_Ignore, GadgetWidth(#Window_Inspector_Api_ScrollArea)-GadgetWidth(#Window_Inspector_Api_ContainerLeft), #PB_Ignore)
  SetGadgetState(#Window_Inspector_Api_Splitter, SplitterPosition)
  
EndProcedure
;}

;- --- [SE] Window Gadget ------------------------------------------------------
;{ [WINDOW GADGETS] Enumeration
Enumeration Windows
  #Window_Gadgets
EndEnumeration

Enumeration Gadgets
  #Window_Gadgets_Tree
EndEnumeration

Enumeration ToolBars_Images
  ;ParentNode
  #Gadget_Standard_Image_ParentNodeOn
  #Gadget_Standard_Image_ParentNodeOff
  ;Gadget Standard
  #Gadget_Standard_Image_button
  #Gadget_Standard_Image_buttonimage
  #Gadget_Standard_Image_calendar
  #Gadget_Standard_Image_canvas
  #Gadget_Standard_Image_checkbox
  #Gadget_Standard_Image_combobox
  #Gadget_Standard_Image_date
  #Gadget_Standard_Image_editor
  #Gadget_Standard_Image_hyperlink
  #Gadget_Standard_Image_image
  #Gadget_Standard_Image_ip
  #Gadget_Standard_Image_listicon
  #Gadget_Standard_Image_listview
  #Gadget_Standard_Image_opengl
  #Gadget_Standard_Image_option
  #Gadget_Standard_Image_progressbar
  #Gadget_Standard_Image_scroll_bar
  #Gadget_Standard_Image_spin
  #Gadget_Standard_Image_string
  #Gadget_Standard_Image_text
  #Gadget_Standard_Image_trackbar
  #Gadget_Standard_Image_tree
  #Gadget_Standard_Image_web
  ;Gadget Menus
  #Gadget_Menus_Image_menu
  #Gadget_Menus_Image_menuimage
  #Gadget_Menus_Image_menupopup
  #Gadget_Menus_Image_menupopupimage
  #Gadget_Menus_Image_toolbar
  ;Gadget Container
  #Gadget_Container_Image_container
  #Gadget_Container_Image_frame
  #Gadget_Container_Image_panel
  #Gadget_Container_Image_scrollarea
  #Gadget_Container_Image_splitter
  ;Gadget Explorer
  #Gadget_Explorer_Image_explorercombo
  #Gadget_Explorer_Image_explorerlist
  #Gadget_Explorer_Image_explorertree
  ;Gadget Layout
  #Gadget_Layout_Image_gridbox
  #Gadget_Layout_Image_hbox
  #Gadget_Layout_Image_multibox
  #Gadget_Layout_Image_singlebox
  #Gadget_Layout_Image_spacer
  #Gadget_Layout_Image_vbox
  ;Gadget Additional
  #Gadget_Additional_Image_mdi
  #Gadget_Additional_Image_scintilla
  #Gadget_Additional_Image_statusbar
  #Gadget_Additional_Image_systray
  #Gadget_Additional_Image_timer
  #Gadget_Additional_Image_xml
  ;Gadget Custom
  #Gadget_Custom_Image_shape
  
EndEnumeration

; Enumeration FormFont
;   #Font_Window_Inspector_0
; EndEnumeration
; 
; LoadFont(#Font_Window_Inspector_0,"Arial", 9)
;}
;{ [WINDOW GADGETS] LoadImage for ToolBars
;ParentNode
LoadImage(#Gadget_Standard_Image_ParentNodeOn,IconPath$ + "\icons\gadgets\ParentNodeOn.png")
LoadImage(#Gadget_Standard_Image_ParentNodeOff,IconPath$ + "\icons\gadgets\ParentNodeOff.png")

;Gadget Standard
LoadImage(#Gadget_Standard_Image_button,IconPath$ + "\icons\gadgets\Standard\button.png")
LoadImage(#Gadget_Standard_Image_buttonimage,IconPath$ + "\icons\gadgets\Standard\buttonimage.png")
LoadImage(#Gadget_Standard_Image_calendar,IconPath$ + "\icons\gadgets\Standard\calendar.png")
LoadImage(#Gadget_Standard_Image_canvas,IconPath$ + "\icons\gadgets\Standard\canvas.png")
LoadImage(#Gadget_Standard_Image_checkbox,IconPath$ + "\icons\gadgets\Standard\checkbox.png")
LoadImage(#Gadget_Standard_Image_combobox,IconPath$ + "\icons\gadgets\Standard\combobox.png")
LoadImage(#Gadget_Standard_Image_date,IconPath$ + "\icons\gadgets\Standard\date.png")
LoadImage(#Gadget_Standard_Image_editor,IconPath$ + "\icons\gadgets\Standard\editor.png")
LoadImage(#Gadget_Standard_Image_hyperlink,IconPath$ + "\icons\gadgets\Standard\hyperlink.png")
LoadImage(#Gadget_Standard_Image_image,IconPath$ + "\icons\gadgets\Standard\image.png")
LoadImage(#Gadget_Standard_Image_ip,IconPath$ + "\icons\gadgets\Standard\ip.png")
LoadImage(#Gadget_Standard_Image_listicon,IconPath$ + "\icons\gadgets\Standard\listicon.png")
LoadImage(#Gadget_Standard_Image_listview,IconPath$ + "\icons\gadgets\Standard\listview.png")
LoadImage(#Gadget_Standard_Image_opengl,IconPath$ + "\icons\gadgets\Standard\opengl.png")
LoadImage(#Gadget_Standard_Image_option,IconPath$ + "\icons\gadgets\Standard\option.png")
LoadImage(#Gadget_Standard_Image_progressbar,IconPath$ + "\icons\gadgets\Standard\progressbar.png")
LoadImage(#Gadget_Standard_Image_scroll_bar,IconPath$ + "\icons\gadgets\Standard\scroll_bar.png")
LoadImage(#Gadget_Standard_Image_spin,IconPath$ + "\icons\gadgets\Standard\spin.png")
LoadImage(#Gadget_Standard_Image_string,IconPath$ + "\icons\gadgets\Standard\string.png")
LoadImage(#Gadget_Standard_Image_text,IconPath$ + "\icons\gadgets\Standard\text.png")
LoadImage(#Gadget_Standard_Image_trackbar,IconPath$ + "\icons\gadgets\Standard\trackbar.png")
LoadImage(#Gadget_Standard_Image_tree,IconPath$ + "\icons\gadgets\Standard\tree.png")
LoadImage(#Gadget_Standard_Image_web,IconPath$ + "\icons\gadgets\Standard\web.png")
;Gadget Menus
LoadImage(#Gadget_Menus_Image_menu,IconPath$ + "\icons\gadgets\Menus\menu.png")
LoadImage(#Gadget_Menus_Image_menuimage,IconPath$ + "\icons\gadgets\Menus\menuimage.png")
LoadImage(#Gadget_Menus_Image_menupopup,IconPath$ + "\icons\gadgets\Menus\menupopup.png")
LoadImage(#Gadget_Menus_Image_menupopupimage,IconPath$ + "\icons\gadgets\Menus\menupopupimage.png")
LoadImage(#Gadget_Menus_Image_toolbar,IconPath$ + "\icons\gadgets\Menus\toolbar.png")
;Gadget Container
LoadImage(#Gadget_Container_Image_container,IconPath$ + "\icons\gadgets\Container\container.png")
LoadImage(#Gadget_Container_Image_frame,IconPath$ + "\icons\gadgets\Container\frame.png")
LoadImage(#Gadget_Container_Image_panel,IconPath$ + "\icons\gadgets\Container\panel.png")
LoadImage(#Gadget_Container_Image_scrollarea,IconPath$ + "\icons\gadgets\Container\scrollarea.png")
LoadImage(#Gadget_Container_Image_splitter,IconPath$ + "\icons\gadgets\Container\splitter.png")
;Gadget Explorer
LoadImage(#Gadget_Explorer_Image_explorercombo,IconPath$ + "\icons\gadgets\Explorer\explorercombo.png")
LoadImage(#Gadget_Explorer_Image_explorerlist,IconPath$ + "\icons\gadgets\Explorer\explorerlist.png")
LoadImage(#Gadget_Explorer_Image_explorertree,IconPath$ + "\icons\gadgets\Explorer\explorertree.png")
;Gadget Layout
LoadImage(#Gadget_Layout_Image_gridbox,IconPath$ + "\icons\gadgets\Layout\gridbox.png")
LoadImage(#Gadget_Layout_Image_hbox,IconPath$ + "\icons\gadgets\Layout\hbox.png")
LoadImage(#Gadget_Layout_Image_multibox,IconPath$ + "\icons\gadgets\Layout\multibox.png")
LoadImage(#Gadget_Layout_Image_singlebox,IconPath$ + "\icons\gadgets\Layout\singlebox.png")
LoadImage(#Gadget_Layout_Image_spacer,IconPath$ + "\icons\gadgets\Layout\spacer.png")
LoadImage(#Gadget_Layout_Image_vbox,IconPath$ + "\icons\gadgets\Layout\vbox.png")
;Gadget Additional
LoadImage(#Gadget_Additional_Image_mdi,IconPath$ + "\icons\gadgets\Additional\mdi.png")
LoadImage(#Gadget_Additional_Image_scintilla,IconPath$ + "\icons\gadgets\Additional\scintilla.png")
LoadImage(#Gadget_Additional_Image_statusbar,IconPath$ + "\icons\gadgets\Additional\statusbar.png")
LoadImage(#Gadget_Additional_Image_systray,IconPath$ + "\icons\gadgets\Additional\systray.png")
LoadImage(#Gadget_Additional_Image_timer,IconPath$ + "\icons\gadgets\Additional\timer.png")
LoadImage(#Gadget_Additional_Image_xml,IconPath$ + "\icons\gadgets\Additional\xml.png")
;Gadget Custom
LoadImage(#Gadget_Custom_Image_shape,IconPath$ + "\icons\gadgets\Custom\shape.png")

;}
;{ [WINDOW GADGETS] Global 
Global NewList Liste_CategoriesGadget.s()
Structure IconGadgets
  Name.s
  NumberIcon.l
EndStructure
Global NewList Liste_AllGadget.IconGadgets()
;}
;{ [WINDOW GADGETS] Declare 
Declare ResizeGadgetsWindow_Gadgets()
;}
;{ [WINDOW GADGETS] Procedures
Procedure TreeViewExpandAll(Gadget.l) 
  ;   ; English forum: http://www.purebasic.fr/english/viewtopic.php?t=6169&highlight=
  ;   ; Author: Inner (updated for PB4.00 by blbltheworm)
  ;   ; Date: 16. May 2003
  ;   ; OS: Windows
  ;   hwndTV.l = GadgetID(Gadget)  
  ;   hRoot.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)  
  ;   hItem.l = hRoot  
  ;   Repeat 
  ;     SendMessage_(hwndTV, #TVM_EXPAND, #TVE_EXPAND, hItem) 
  ;     hItem = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXTVISIBLE , hItem)  
  ;   Until hItem = #Null  
  ;   SendMessage_(hwndTV, #TVM_ENSUREVISIBLE, 0, hRoot)
  Protected i
  
  For i = 0 To CountGadgetItems(Gadget) - 1
    SetGadgetItemState(Gadget, i, #PB_Tree_Expanded)
  Next i
EndProcedure 
Procedure TreeViewCollapseAll(Gadget.l) 
  ;   hwndTV.l = GadgetID(Gadget)  
  ;   hRoot.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)  
  ;   hItem.l = hRoot  
  ;   Repeat 
  ;     SendMessage_(hwndTV, #TVM_EXPAND, #TVE_COLLAPSE, hItem) 
  ;     hItem = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXTVISIBLE , hItem)  
  ;   Until hItem = #Null  
  ;   SendMessage_(hwndTV, #TVM_ENSUREVISIBLE, 0, hRoot) 
  Protected i
  
  For i = 0 To CountGadgetItems(Gadget) - 1
    SetGadgetItemState(Gadget, i, #PB_Tree_Collapsed)
  Next i
  
EndProcedure 
Procedure OpenWindow_Gadgets(x = 825, y = 335, width = 190, height = 400)
  Protected tmp$, ColorNodeParent, NodeParentNumber, iconeID
  
  OpenWindow(#Window_Gadgets, x, y, width, height, "Gadgets", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_Tool)
  TreeGadget(#Window_Gadgets_Tree, 0, 0, 190, 400, #PB_Tree_AlwaysShowSelection)
  PrefPath$=GetCurrentDirectory()+"Prefs\gadgets\"
  
  ;List categories from Categories.txt = ParentNodes
  If ReadFile(0, PrefPath$+"Categories.txt")                                          
    While Eof(0) = 0 
      tmp$=ReadString(0) 
      AddElement(Liste_CategoriesGadget()) 
      Liste_CategoriesGadget()=tmp$ 
    Wend
    CloseFile(0) 
  Else
    MessageRequester("Information","Categories.txt is missing!")
  EndIf
  
  ;Open each file (category) containing gadgets = ChildNodes
  ColorNodeParent=RGB(0, 0, 255)
  NodeParentNumber=0
  iconeID=#Gadget_Standard_Image_button
  ForEach Liste_CategoriesGadget()
    AddGadgetItem (#Window_Gadgets_Tree, -1, Liste_CategoriesGadget(), ImageID(#Gadget_Standard_Image_ParentNodeOn), 0) 
    SetGadgetItemColor(#Window_Gadgets_Tree,NodeParentNumber,#PB_Gadget_FrontColor, ColorNodeParent)
    NodeParentNumber+1
    If ReadFile(0, PrefPath$+Liste_CategoriesGadget()+".txt")
      While Eof(0) = 0 
        tmp$=ReadString(0)
        AddElement(Liste_AllGadget()) 
        Liste_AllGadget()\Name=tmp$
        Liste_AllGadget()\NumberIcon=iconeID
        AddGadgetItem (#Window_Gadgets_Tree, -1, tmp$, ImageID(iconeID), 1)
        NodeParentNumber+1
        iconeID+1
      Wend
      CloseFile(0)
    Else
      MessageRequester("Information","File is missing!")
    EndIf
    
    ;Resultat = AddGadgetItem(#Gadget, Position, Texte$ [, ImageID [, sous-niveau du nouvel item.]])
    ;ImageID(x)
  Next 
  
  ;Add a parent node names All Gadgets
  SortStructuredList(Liste_AllGadget(),#PB_Sort_Ascending|#PB_Sort_NoCase ,OffsetOf(IconGadgets\Name),TypeOf(IconGadgets\Name))
  iconeID=#Gadget_Standard_Image_button
  AddGadgetItem (#Window_Gadgets_Tree, -1, "All Gadgets", ImageID(#Gadget_Standard_Image_ParentNodeOn), 0)
  ForEach Liste_AllGadget()
    AddGadgetItem (#Window_Gadgets_Tree, -1, Liste_AllGadget()\Name, ImageID(Liste_AllGadget()\NumberIcon), 1)
    iconeID+1
  Next
  ColorNodeParent=RGB(0, 128, 0)
  SetGadgetItemColor(#Window_Gadgets_Tree,NodeParentNumber,#PB_Gadget_FrontColor, ColorNodeParent)
  
  TreeViewExpandAll(#Window_Gadgets_Tree)
  
EndProcedure
Procedure ResizeGadgetsWindow_Gadgets()
  Protected FormWindowWidth, FormWindowHeight
  FormWindowWidth = WindowWidth(#Window_Gadgets)
  FormWindowHeight = WindowHeight(#Window_Gadgets)
  ResizeGadget(#Window_Gadgets_Tree, 0, 0, FormWindowWidth - 0, FormWindowHeight - 0)
EndProcedure
;}

;- --- [Center] Window with TabBar on Center ------------------------------------------
;{ [WINDOW TABBAR] Enumeration
Enumeration Windows
  #Window_Center_TABBAR
EndEnumeration

Enumeration Gadgets
  #Window_Center_TABBAR_TabBar_Top
  #Window_Center_TABBAR_Scintilla ; constante or variable ?
EndEnumeration

Enumeration ToolBars_Images
  #Img_Window_Center_TABBAR_Form
  #Img_Window_Center_TABBAR_Code
  #Img_Window_Center_TABBAR_New
EndEnumeration
;}
;{ [WINDOW TABBAR] LoadImage for ToolBars
LoadImage(#Img_Window_Center_TABBAR_Form,IconPath$ + "\icons\gadgets\application.png")
LoadImage(#Img_Window_Center_TABBAR_Code,IconPath$ + "\icons\gadgets\code.png")
LoadImage(#Img_Window_Center_TABBAR_New,IconPath$ + "\icons\gadgets\add.png")
;}
;{ [WINDOW TABBAR] Global 
;{ needed to have a window resizable but without titlebar and with thin borders
Structure NCCALCSIZE_PARAMS2
  rgrc.RECT[3]
  *lppos.WINDOWPOS
EndStructure
;Global 
;Thickness of resizable borders
Global gWindow_Center_TABBAR_FrameWidth = GetSystemMetrics_(#SM_CXSIZEFRAME)
Global gWindow_Center_TABBAR_CaptionHeight = GetSystemMetrics_(#SM_CYSIZEFRAME)
;}
;}
;{ [WINDOW TABBAR] Declare 
Declare ResizeGadgetsWindow_Center_TABBAR()
;}
;{ [WINDOW TABBAR] Procedures
;{ CallbackScintilla
; ProcedureDLL CallbackScintilla(#Window_Center_TABBAR_Scintilla, *scinotify.SCNotification)
;  
; EndProcedure
;}
Procedure MakeScintillaText(texte.s)
  ; To display purebasic code
  Static sciTexte.s
  CompilerIf #PB_Compiler_Unicode
    sciTexte = Space(StringByteLength(texte, #PB_UTF8))
    PokeS(@sciTexte, texte, -1, #PB_UTF8)
  CompilerElse
    sciTexte = texte
  CompilerEndIf
  ProcedureReturn @sciTexte
EndProcedure
Procedure Window_Center_TABBAR_Winproc(hwnd, msg, wParam, lParam)
  Protected *np.NCCALCSIZE_PARAMS2, wr.RECT
  Protected hdcDest, hdcSrc, hdc, hrgn, hrgn2, imgtmp
  ;by netmaestro
  ;http://www.purebasic.fr/english/viewtopic.php?f=5&t=61726
  ; needed to have a window resizable but without titlebar and with thin borders
  Select msg
    Case #WM_NCCALCSIZE
      *np = lparam;*np.NCCALCSIZE_PARAMS2 = lparam
      SetRect_(*np\rgrc[0],
               *np\lppos\x+gWindow_Center_TABBAR_FrameWidth,
               *np\lppos\y+gWindow_Center_TABBAR_CaptionHeight,
               *np\lppos\x+*np\lppos\cx-gWindow_Center_TABBAR_FrameWidth,
               *np\lppos\y+*np\lppos\cy-gWindow_Center_TABBAR_CaptionHeight)
      
      ProcedureReturn #WVR_VALIDRECTS | #WVR_REDRAW 
      
    Case #WM_NCPAINT, #WM_NCACTIVATE
      If msg = #WM_NCACTIVATE And wparam = #False
        ProcedureReturn #True
      EndIf
      GetWindowRect_(hwnd, wr);wr.RECT
      hdcDest = GetWindowDC_(hwnd) 
      hdcSrc = CreateCompatibleDC_(hdc) ; here hdc=0 : current screen
      hrgn = CreateRectRgn_(0,0,wr\right-wr\left, wr\bottom-wr\top) 
      hrgn2 = CreateRectRgn_(gWindow_Center_TABBAR_FrameWidth,gWindow_Center_TABBAR_CaptionHeight,wr\right-wr\left-gWindow_Center_TABBAR_FrameWidth,wr\bottom-wr\top-gWindow_Center_TABBAR_CaptionHeight) 
      CombineRgn_(hrgn, hrgn, hrgn2, #RGN_XOR) 
      SelectClipRgn_(hdcDest, hrgn) 
      imgtmp = CreateImage(#PB_Any, wr\right-wr\left,wr\bottom-wr\top,24,GetSysColor_(#COLOR_BTNFACE))
      SelectObject_(hdcSrc, ImageID(imgtmp))
      BitBlt_(hdcDest,0,0,wr\right-wr\left, wr\bottom-wr\top,hdcSrc,0,0,#SRCCOPY)
      FreeImage(imgtmp)
      DeleteDC_(hdcSrc)
      ReleaseDC_(hwnd, hdcDest) 
      DeleteObject_(hrgn)
      DeleteObject_(hrgn2)
      ; 			Debug "resize"
      ;ResizeGadgetsWindow_Gadgets()
      
      
      ProcedureReturn #False
      
    Case #WM_LBUTTONDOWN
      SendMessage_(hwnd, #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
      
      ; 		Case #WM_RBUTTONUP
      ; 			DisplayPopupMenu(id, WindowID(#Window_Center_TABBAR))
      ; 		ResizeGadgetsWindow_Gadgets()	
      
    Case #WM_LBUTTONDBLCLK
      ResizeWindow(#Window_Center_TABBAR,WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate),WindowHeight(#Window_Main,#PB_Window_FrameCoordinate),DesktopWidth-WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate)-WindowWidth(#Window_Gadgets,#PB_Window_FrameCoordinate)-2*gWindow_Center_TABBAR_FrameWidth,#PB_Ignore)
      
  EndSelect
  
  ProcedureReturn #PB_ProcessPureBasicEvents
  
EndProcedure
Procedure OpenWindow_Center_TABBAR(x = 253, y = 141, width = 570, height = 625)
  Protected TabBarAttributes, Text$
  
  ; A window resizable but without titlebar and with thin borders
  OpenWindow(#Window_Center_TABBAR, x, y, width, height, "", #PB_Window_SizeGadget)
  SetWindowLongPtr_(WindowID(#Window_Center_TABBAR), #GWL_STYLE,GetWindowLongPtr_(WindowID(#Window_Center_TABBAR), #GWL_STYLE) &~ #WS_SYSMENU)
  SetWindowCallback(@Window_Center_TABBAR_Winproc(), #Window_Center_TABBAR)
  SetWindowPos_(WindowID(#Window_Center_TABBAR),0,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_NOZORDER|#SWP_FRAMECHANGED)
  
  
  ;OpenWindow(#Window_Center_TABBAR, x, y, width, height, "", #PB_Window_BorderLess| #WS_SIZEBOX )
  ;SetWindowColor(#Window_Center_TABBAR,$ffffff)
  ;ContainerGadget(#Window_Center_TABBAR_TabBar_Top, 0, 0, 605, 40)
  If InitScintilla() = 0
    MessageRequester("Attention", "'scintilla.dll is needed in the path.")
  EndIf
  TabBarAttributes = #TabBarGadget_CloseButton|#TabBarGadget_Editable|#TabBarGadget_NewTab|#TabBarGadget_TextCutting;|#TabBarGadget_PopupButton
  TabBarGadget(#Window_Center_TABBAR_TabBar_Top, 0, 0, WindowWidth(#Window_Center_TABBAR), #TabBarGadget_DefaultHeight, TabBarAttributes, #Window_Center_TABBAR)
  AddTabBarGadgetItem(#Window_Center_TABBAR_TabBar_Top, #PB_Default, "Form1_Form", ImageID(#Img_Window_Center_TABBAR_Form))
  AddTabBarGadgetItem(#Window_Center_TABBAR_TabBar_Top, #PB_Default, "Form1_Code", ImageID(#Img_Window_Center_TABBAR_Code))
  ; Make a difference between Form and Code (for the future) 0 = form ; 1 = Code
  SetTabBarGadgetItemData( #Window_Center_TABBAR_TabBar_Top, 0, 0) ; 0 = Form
  SetTabBarGadgetItemData( #Window_Center_TABBAR_TabBar_Top, 1, 1) ; 1 = Code
                                                                   ; Tab New is a specific tab	
  AddTabBarGadgetItem(#Window_Center_TABBAR_TabBar_Top, #TabBarGadgetItem_NewTab, "New", ImageID(#Img_Window_Center_TABBAR_New))
  ; ToolTips	
  TabBarGadgetToolTip(#Window_Center_TABBAR_TabBar_Top, "%ITEM", "new", "close")
  ScintillaGadget(#Window_Center_TABBAR_Scintilla, 0, GadgetHeight(#Window_Center_TABBAR_TabBar_Top), 572, 625-GadgetHeight(#Window_Center_TABBAR_TabBar_Top),0 );@CallbackScintilla()
                                                                                                                                                                 ; Add some text in scintilla                                                                                                                                                               ; Add some text
                                                                                                                                                                 ; Commentary (Text in green)
  ScintillaSendMessage(#Window_Center_TABBAR_Scintilla, #SCI_STYLESETFORE, 0, RGB(0, 170, 170))      
  ScintillaSendMessage(#Window_Center_TABBAR_Scintilla, #SCI_SETTEXT, 0, MakeScintillaText("; Pure-Dialog Designer"))
  Text$ = Chr(10) + "; Form1"
  ScintillaSendMessage(#Window_Center_TABBAR_Scintilla, #SCI_APPENDTEXT, Len(Text$), MakeScintillaText(Text$))
  
  HideGadget(#Window_Center_TABBAR_Scintilla, #True)
  
EndProcedure
Procedure ResizeGadgetsWindow_Center_TABBAR()
  Protected FormWindowWidth, FormWindowHeight
  FormWindowWidth = WindowWidth(#Window_Center_TABBAR)
  FormWindowHeight = WindowHeight(#Window_Center_TABBAR)
  ResizeGadget(#Window_Center_TABBAR_TabBar_Top, 0, 0, FormWindowWidth - 0, #PB_Ignore);40
                                                                                       ;Debug "resize"
  ResizeGadget(#Window_Center_TABBAR_Scintilla, 0, #PB_Ignore, FormWindowWidth - 0, FormWindowHeight - GadgetHeight(#Window_Center_TABBAR_TabBar_Top))
EndProcedure
;}

;- --- [Center] WORKING WINDOW on Center ------------------------------------------
;{ [Procedures]
Procedure WorkingWindowCreate()
  
EndProcedure

;}

;- /////////////////////////   MAIN   /////////////////////////////
; *** Open All Windows **********************
; >>> Window on the Top
GetDesktopRect()  ;Get the dimensions of the desktop
OpenWindow_Top()  ;Open the TopWindow but don't show her because there're a lot of gadgets
HideWindow(#Window_Main, #False)  ; Show the TopWindow

; >>> FormList NE
OpenWindow_ListForm()

; >>> Gadgets TreeView NW
OpenWindow_GadgetsTreeView()

; >>> Inspector SW
OpenWindow_Inspector()

; >>> Gadgets SE
OpenWindow_Gadgets()

; >>> Center of the screen TABBAR
OpenWindow_Center_TABBAR()

; ; >>> Window to work with
; top=WindowHeight(#Window_Main,#PB_Window_FrameCoordinate)
; NewWindow_0=OpenWindow(#PB_Any,210,top,605,590,"Form1",#PB_Window_SystemMenu)
; SetActiveWindow(NewWindow_0)


; *** Resize Windows **********************
; resize top window is not necessary
ResizeWindow(#FormList_Window, DesktopWidth-WindowWidth(#FormList_Window,#PB_Window_FrameCoordinate),#PB_Ignore,#PB_Ignore,#PB_Ignore)

ResizeWindow(#Window_GadgetsTreeView,#PB_Ignore,#PB_Ignore,WindowWidth(#Window_Inspector),#PB_Ignore)
ResizeWindow(#Window_Inspector,#PB_Ignore,#PB_Ignore,#PB_Ignore,DesktopHeight-WindowY(#Window_Inspector)-30)
ResizeWindow(#Window_Gadgets,#PB_Ignore,#PB_Ignore,#PB_Ignore,DesktopHeight-WindowY(#Window_Gadgets)-30)
ResizeWindow(#Window_Center_TABBAR,WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate),#PB_Ignore,DesktopWidth-WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate)-WindowWidth(#Window_Gadgets,#PB_Window_FrameCoordinate)-2*gWindow_Center_TABBAR_FrameWidth,#PB_Ignore)
ResizeWindow(#Window_Gadgets, DesktopWidth-WindowWidth(#Window_Gadgets,#PB_Window_FrameCoordinate),WindowY(#FormList_Window)+WindowWidth(#FormList_Window,#PB_Window_FrameCoordinate),#PB_Ignore,DesktopHeight-WindowY(#Window_Gadgets))
;ResizeWindow(NewWindow_0,WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate)+10,#PB_Ignore,DesktopWidth-WindowWidth(#Window_Inspector,#PB_Window_FrameCoordinate)-WindowWidth(#Window_Gadgets,#PB_Window_FrameCoordinate)-20,#PB_Ignore)


;Global string to make a window
Global Enumeration_Windows.s
Global OpenWindow.s

;Loop Variable
Global hButton, event, Window, Menu, GadgetClicked, quit,  Direction
Global Tab;[Center] WINDOW TABBAR WINDOW



;- /////////////////////////   LOOP   /////////////////////////////
Repeat
  ;{-Panel of the window Inspector with tab at the bottom
  ; 
  ;   pgStatic = 0
  ;     For i = 1 To CountGadgetItems(#Window_Inspector_Panel)
  ;       pgStatic = FindWindowEx_(hWindow_Inspector_Panel, pgStatic, "Static", 0)
  ;       MoveWindow_(pgStatic, 0, 0, 260, 180, 1)
  ;     Next i
  ;}
  hButton=SpeeButtonEvent(#Window_Main)
  event = WaitWindowEvent()
  Window = EventWindow()
  Menu = EventMenu()
  GadgetClicked= EventGadget()
  
  Select Window
                ;{---------------------- [N] TOP WINDOW   ---------------------------- 
    Case #Window_Main
      
      Select event          
          
        Case #PB_Event_CloseWindow
          quit=#True
          
        Case #PB_Event_Menu
          ;{ Menu + TollBars + Panel (gadgets
          Debug Menu
          Select Menu
            Case #MenuItem_File_New
            Case #MenuItem_File_open
            Case #MenuItem_File_Close_Form
            Case #MenuItem_File_Save
            Case #MenuItem_File_SaveAs
            Case #MenuItem_File_SaveAll
            Case #MenuItem_File_RecentFiles_1
            Case #MenuItem_File_Import_PureFormDesigner
            Case #MenuItem_File_Import_ExternalImport
            Case #MenuItem_File_Exit
            Case #MenuItem_Edit_Undo
            Case #MenuItem_Edit_Cut
            Case #MenuItem_Edit_Copy
            Case #MenuItem_Edit_Paste
            Case #MenuItem_Delete
            Case #MenuItem_Edit_SelectAll
            Case #MenuItem_Edit_TabOrder
            Case #MenuItem_Edit_Gadget_Bringtofront
            Case #MenuItem_Edit_Gadget_Sendtoback
            Case #MenuItem_Edit_Gadget_Lock
            Case #MenuItem_Edit_Gadget_Unlock
            Case #MenuItem_Edit_Gadget_Noinsertin
            Case #MenuItem_Edit_Gadget_Nocopy
            Case #MenuItem_Edit_Align_Left
            Case #MenuItem_Edit_Align_Center
            Case #MenuItem_Edit_Align_Right
            Case #MenuItem_Edit_Align_Top
            Case #MenuItem_Edit_Align_Middle
            Case #MenuItem_Edit_Align_Bottom
            Case #MenuItem_Edit_Align_SpaceEquallyHorizontally
            Case #MenuItem_Edit_Align_SpaceEquallyVertically
            Case #MenuItem_Edit_Align_CenterHorizontallyInWindow
            Case #MenuItem_Edit_Align_CenterVerticallyInWindow
            Case #MenuItem_Edit_Align_EqualWidth
            Case #MenuItem_Edit_Align_EqualHeight
            Case #MenuItem_Edit_Align_EqualSizeht
            Case #MenuItem_Edit_Align_ToGrid
            Case #MenuItem_View_ObjectTree
            Case #MenuItem_View_ObjectInspector
            Case #MenuItem_View_FormList
            Case #MenuItem_View_Snippets
            Case #MenuItem_Options_Options
            Case #MenuItem_Options_RememberPosition
            Case #MenuItem_Tools_GeneratingFormCode
            Case #MenuItem_Tools_GeneratingOptions
            Case #MenuItem_Tools_RunForm
            Case #MenuItem_Tools_UpdateScript
            Case #MenuItem_Forms_Form1
            Case #MenuItem_Wizards_AllPlatforms
            Case #MenuItem_Wizards_Windows
            Case #MenuItem_Wizards_MacOs
            Case #MenuItem_Wizards_Linux
            Case #MenuItem_Snippets_AllPlatforms
            Case #MenuItem_Snippets_Windows
            Case #MenuItem_Snippets_MacOs
            Case #MenuItem_Snippets_Linux
            Case #MenuItem_Help_Content
            Case #MenuItem_Help_CheckLatestVersion
            Case #MenuItem_Help_About
          EndSelect ;Menu
                    ;}
          
        Case #PB_Event_Timer 
          ;{ Needed to use the 2 buttons on the tab "standard" to scroll icons left/right
          ; Note: The Timer n°100 is killed each time one of those 2 buttons are released (LefButtonUp).
          If TopWindow_MouseLeftButton_Pressed=1
            Select hButton
              Case hButtonSpeedUP
                Direction=32     ; 32 because icons are 32x32
                IndentIconsTabStandard=IndentIconsTabStandard+32
                
              Case hButtonSpeedDOWN
                Direction=-32
                IndentIconsTabStandard=IndentIconsTabStandard-32
                
            EndSelect ;hButton speedButton            
            
            If IndentIconsTabStandard>0
              IndentIconsTabStandard=0
            EndIf
            
            ;             NbIconsInTabStandard = SendMessage_(hTB2, #TB_BUTTONCOUNT, 0, 0)
            If IndentIconsTabStandard<- NbIconsInTabStandard*32
              IndentIconsTabStandard=- NbIconsInTabStandard*32
            EndIf
            
            ; The toolBar is indented by 32 pixels
            SendMessage_(hTB2 ,#TB_SETINDENT,IndentIconsTabStandard,0);
                                                                      ;need to reaffect tooltips of each icons
            ToolBarToolTip(2, #Toolbar_TabStandard_acursor, "acursor")
            ToolBarToolTip(2, #Toolbar_TabStandard_button, "button")
            ToolBarToolTip(2, #Toolbar_TabStandard_buttonimage, "buttonimage")
            ToolBarToolTip(2, #Toolbar_TabStandard_calendar, "calendar")
            ToolBarToolTip(2, #Toolbar_TabStandard_canvas, "canvas")
            ToolBarToolTip(2, #Toolbar_TabStandard_checkbox, "checkbox")
            ToolBarToolTip(2, #Toolbar_TabStandard_combobox, "combobox")
            ToolBarToolTip(2, #Toolbar_TabStandard_date, "date")
            ToolBarToolTip(2, #Toolbar_TabStandard_editor, "editor")
            ToolBarToolTip(2, #Toolbar_TabStandard_hyperlink, "hyperlink")
            ToolBarToolTip(2, #Toolbar_TabStandard_image, "image")
            ToolBarToolTip(2, #Toolbar_TabStandard_ip, "ip")
            ToolBarToolTip(2, #Toolbar_TabStandard_listicon, "listicon")
            ToolBarToolTip(2, #Toolbar_TabStandard_listview, "listview")
            ToolBarToolTip(2, #Toolbar_TabStandard_opengl, "opengl")
            ToolBarToolTip(2, #Toolbar_TabStandard_option, "option")
            ToolBarToolTip(2, #Toolbar_TabStandard_progressbar, "progressbar")
            ToolBarToolTip(2, #Toolbar_TabStandard_scroll_bar, "scroll_bar")
            ToolBarToolTip(2, #Toolbar_TabStandard_shortcut, "shortcut")
            ToolBarToolTip(2, #Toolbar_TabStandard_spin, "spin")
            ToolBarToolTip(2, #Toolbar_TabStandard_string, "string")
            ToolBarToolTip(2, #Toolbar_TabStandard_text, "text")
            ToolBarToolTip(2, #Toolbar_TabStandard_trackbar, "trackbar")
            ToolBarToolTip(2, #Toolbar_TabStandard_tree, "tree")
            ToolBarToolTip(2, #Toolbar_TabStandard_web, "web")
            
          EndIf
          ;}
          

          
      EndSelect ;event 
                ;}
                ;{---------------------  NEW WINDOW   --------------------------------
                ;     Case NewWindow_0
                ;       x = WindowMouseX(NewWindow_0) 
                ;       y=WindowMouseY(NewWindow_0)
                ;       SetWindowTitle(NewWindow_0,"x="+Str(x)+" y="+Str(y))
                ;       Select event
                ;         Case #PB_Event_CloseWindow
                ;           ;  "new window"
                ;           quit=#True
                ;           
                ;           
                ;         Case #PB_Event_LeftClick
                ;           SetActiveWindow(NewWindow_0)
                ;           gadgetlist=ButtonGadget(#PB_Any ,x,y,30,30,"ok")
                ;           
                ;       EndSelect ;event 
                ;} 
                ;{--------------------- [NE] WINDOW FORMLIST   -----------------------
    Case  #FormList_Window
      Select event
        Case #PB_Event_CloseWindow
          ;  "FORMLIST window"
          quit=#True
          
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #FormList_ListIcon
              Select EventType()
                  ;Case #PB_EventType_LeftClick        : Debug "Clic avec le bouton gauche de la souris"
                Case #PB_EventType_RightClick         ;: Debug "Clic avec le bouton droit de la souris"
                  DisplayPopupMenu(PopUpMenu_Window_ListForm, WindowID(#FormList_Window))
                  ;Case #PB_EventType_LeftDoubleClick  : Debug "Double-clic avec le bouton gauche de la souris"
                  ;Case #PB_EventType_RightDoubleClick : Debug "Double-clic avec le bouton droit de la souris"
              EndSelect
          EndSelect
          
        Case #PB_Event_Menu 
          Select Menu
            Case #MenuItem_File_Close_Form : Debug "close"
            Case #MenuItem_File_New : Debug "new"
              
          EndSelect
          
        Case #PB_Event_SizeWindow 
          ResizeGadgets_Window_ListForm()
          
      EndSelect ;event 
                ;}
                ;{--------------------- [NW] WINDOW GADGET TREEVIEW   ----------------
    Case  #Window_GadgetsTreeView
      Select event
        Case #PB_Event_CloseWindow
          ;  "FORMLIST window"
          quit=#True
          
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #Window_GadgetsTreeView_Tree
              Select EventType()
                  ;Case #PB_EventType_LeftClick        : Debug "Clic avec le bouton gauche de la souris"
                Case #PB_EventType_RightClick       ;: Debug "Clic avec le bouton droit de la souris"
                  DisplayPopupMenu(PopUpMenu_Window_GadgetsTreeView, WindowID(#Window_GadgetsTreeView))
                  ;Case #PB_EventType_LeftDoubleClick  : Debug "Double-clic avec le bouton gauche de la souris"
                  ;Case #PB_EventType_RightDoubleClick : Debug "Double-clic avec le bouton droit de la souris"
              EndSelect
          EndSelect
          
        Case #PB_Event_Menu 
          ;{ PopUpMenu
          Debug Menu
          Select Menu
            Case #MenuItem_Edit_Cut
            Case #MenuItem_Edit_Copy
            Case #MenuItem_Edit_Paste
            Case #MenuItem_Delete
            Case #MenuItem_Edit_SelectAll
            Case #MenuItem_Edit_TabOrder
              ;SubMenu("&Gadget")
            Case #MenuItem_Edit_Gadget_Bringtofront
            Case #MenuItem_Edit_Gadget_Sendtoback
            Case #MenuItem_Edit_Gadget_Lock
            Case #MenuItem_Edit_Gadget_Unlock
            Case #MenuItem_Edit_Gadget_Noinsertin
            Case #MenuItem_Edit_Gadget_Nocopy
              ;SubMenu("Align")
            Case #MenuItem_Edit_Align_Left
            Case #MenuItem_Edit_Align_Center
            Case #MenuItem_Edit_Align_Right
            Case #MenuItem_Edit_Align_Top
            Case #MenuItem_Edit_Align_Middle
            Case #MenuItem_Edit_Align_Bottom
            Case #MenuItem_Edit_Align_SpaceEquallyHorizontally
            Case #MenuItem_Edit_Align_SpaceEquallyVertically
            Case #MenuItem_Edit_Align_CenterHorizontallyInWindow
            Case #MenuItem_Edit_Align_CenterVerticallyInWindow
            Case #MenuItem_Edit_Align_EqualWidth
            Case #MenuItem_Edit_Align_EqualHeight
            Case #MenuItem_Edit_Align_EqualSizeht
            Case #MenuItem_Edit_Align_ToGrid           
          EndSelect
          ;}
          
        Case #PB_Event_SizeWindow 
          ResizeGadgets_Window_GadgetsTreeView()
          
          
      EndSelect ;event
                ;}
                ;{--------------------- [SW] WINDOW INSPECTOR  -----------------------    
    Case  #Window_Inspector
      Select event
        Case #PB_Event_CloseWindow
          ;  "FORMLIST window"
          quit=#True
          
        Case #PB_Event_Gadget
          Select EventGadget()
        ;{ Resize gadgets after using splitters
            Case #Window_Inspector_Properties_Splitter
              ;Window_Inspector_Properties_Splitter_Position= GetGadgetState(#Window_Inspector_Properties_Splitter)
              ;Debug Window_Inspector_Properties_Splitter_Position
              ;Case #Window_Inspector_Properties_ScrollArea
              ;Debug GetGadgetAttribute(#Window_Inspector_Properties_ScrollArea,#PB_ScrollArea_Y)
              ForEach Window_Inspector_GadgetsProperties()
                ResizeGadget(Window_Inspector_GadgetsProperties()\IDKeyGadget, #PB_Ignore , #PB_Ignore , GadgetWidth(#Window_Inspector_Properties_ContainerLeft)-LittleButtonWidth, #PB_Ignore )
                ResizeGadget(Window_Inspector_GadgetsProperties()\IDValueGadget, #PB_Ignore , #PB_Ignore ,GadgetWidth(#Window_Inspector_Properties_ContainerRight), #PB_Ignore )
              Next
              
            Case #Window_Inspector_Events_Splitter
              ;Debug GetGadgetState(#Window_Inspector_Events_Splitter)
              ForEach Window_Inspector_GadgetsEvents()
                ResizeGadget(Window_Inspector_GadgetsEvents()\IDKeyGadget, #PB_Ignore , #PB_Ignore , GadgetWidth(#Window_Inspector_Events_ContainerLeft)-LittleButtonWidth, #PB_Ignore )
                ResizeGadget(Window_Inspector_GadgetsEvents()\IDValueGadget, #PB_Ignore , #PB_Ignore ,GadgetWidth(#Window_Inspector_Events_ContainerRight), #PB_Ignore )
              Next
              
              Case #Window_Inspector_Api_Splitter
              ForEach Window_Inspector_GadgetsApi()
                ResizeGadget(Window_Inspector_GadgetsApi()\IDKeyGadget, #PB_Ignore , #PB_Ignore , GadgetWidth(#Window_Inspector_Api_ContainerLeft)-LittleButtonWidth, #PB_Ignore )
                ResizeGadget(Window_Inspector_GadgetsApi()\IDValueGadget, #PB_Ignore , #PB_Ignore ,GadgetWidth(#Window_Inspector_Api_ContainerRight), #PB_Ignore )
              Next
         ;}
          EndSelect
         
        Case #PB_Event_SizeWindow 
          ResizeGadgets_Window_Inspector()
          
          
      EndSelect ;event
                ;}
                ;{--------------------- [SE] WINDOW GADGET  -------------------------- 
    Case #Window_Gadgets
      Select event
        Case #PB_Event_CloseWindow
          ;  "FORMLIST window"
          quit=#True
          
          ;         Case #PB_Event_Gadget
          ;           Select EventGadget()
          ;             Case 
          ;               Select EventType()
          ;                   ;Case #PB_EventType_LeftClick        : Debug "Clic avec le bouton gauche de la souris"
          ;                   ;Case #PB_EventType_RightClick       ;: Debug "Clic avec le bouton droit de la souris"
          ;                   
          ;                   ;Case #PB_EventType_LeftDoubleClick  : Debug "Double-clic avec le bouton gauche de la souris"
          ;                   ;Case #PB_EventType_RightDoubleClick : Debug "Double-clic avec le bouton droit de la souris"
          ;               EndSelect
          ;           EndSelect
          
          
          
        Case #PB_Event_SizeWindow 
          ResizeGadgetsWindow_Gadgets()
          
      EndSelect ;event
                ;}
                ;{--------------------- [Center] WINDOW TABBAR  ----------------------
    Case #Window_Center_TABBAR
      Select event
          ;         Case #PB_Event_CloseWindow
          ;           FreeTabBarGadget(#Window_Center_TABBAR_TabBar_Top)
          ;           quit=#True
          
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #Window_Center_TABBAR_TabBar_Top
              Select EventType()                 
                Case #TabBarGadget_EventType_Change       ; Tab has changed
                  Debug "selected item changed, now at position "+Str(GetTabBarGadgetItemPosition(EventGadget(), #TabBarGadgetItem_Event))
                                                          ;Position.i = GetTabBarGadgetItemPosition( Gadget.i, Tab.i )
                                                          ;Tab 	The position of the tab (the first tab is 0) 
                                                          ; Or the unique ID (see TabBarGadgetItemID) of the tab 
                                                          ; Or one of the following constants:
                                                          ;#TabBarGadgetItem_Event 	The tab With the last event.
                                                          ;#TabBarGadgetItem_Selected 	The selected tab.
                                                          ;#TabBarGadgetItem_NewTab 	The "new" tab.
                  
                  Tab=GetTabBarGadgetItemData(#Window_Center_TABBAR_TabBar_Top, #TabBarGadgetItem_Selected )
                  If Tab = 0 ; odd
                    HideGadget(#Window_Center_TABBAR_Scintilla, #True)
                  Else
                    HideGadget(#Window_Center_TABBAR_Scintilla, #False)
                  EndIf
                  
                  
                Case #TabBarGadget_EventType_Resize       ; Gadget size has changed
                Case #TabBarGadget_EventType_NewItem      ; Before a New Tab
                                                          ;NewForm_AddNewForm()
                Case #TabBarGadget_EventType_CloseItem    ; Before a Tab closed
                                                          ;NewForm_CloseForm()
                Case #TabBarGadget_EventType_SwapItem     ; Tab focus has changed
                Case #TabBarGadget_EventType_EditItem     ; Text of a tab has changed
                Case #TabBarGadget_EventType_CheckBox     ; Checkbox state of the tab has changed
                Case #TabBarGadget_EventType_PopupButton  ; The Popup-Button has been pushed
                  
              EndSelect ;EventType()
                        ;UpdateItemAttributes(GetItemGadgetState())
              
          EndSelect     ;EventGadget()
        Case #PB_Event_SizeWindow 
          ;Debug "resize"
          ResizeGadgetsWindow_Center_TABBAR()
      EndSelect ;event
                ;}
  EndSelect     ;Window  
  
Until quit=#True

End
; IDE Options = PureBasic 5.40 LTS Beta 8 (Windows - x86)
; CursorPosition = 2464
; FirstLine = 92
; Folding = AACAAAAAAAIAw
; EnableXP
; CompileSourceDirectory