Procedure WindowMouseButton(Wnd, ButtonNr)
	
	CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	;Linux Version
	
	Protected gdkWnd.l, x.l, y.l, mask.l
	Protected *Window.GTKWindow
	
	If Wnd
		*Window = Wnd
		gdkWnd = *Window\bin\child\window
		gdk_window_get_pointer_(gdkWnd, @x, @y, @mask)
		
		Select ButtonNr
			Case 0
				If (mask & #GDK_BUTTON1_MASK)
					ProcedureReturn #True
				EndIf
			Case 1
				If (mask & #GDK_BUTTON3_MASK)
					ProcedureReturn #True
				EndIf
			Case 2
				If (mask & #GDK_BUTTON2_MASK)
					ProcedureReturn #True
				EndIf
		EndSelect
	EndIf
	
	CompilerElse
	;Windows Version
	
	If Wnd And GetForegroundWindow_() = Wnd
		Select ButtonNr
			Case 0
				If GetAsyncKeyState_(#VK_LBUTTON) > 0
					ProcedureReturn #True
				EndIf
			Case 1
				If GetAsyncKeyState_(#VK_RBUTTON) > 0
					ProcedureReturn #True
				EndIf
			Case 2
				If GetAsyncKeyState_(#VK_MBUTTON) > 0
					ProcedureReturn #True
				EndIf
		EndSelect
	EndIf
	
	CompilerEndIf
	
	ProcedureReturn #False
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = -
; EnableXP