DataSection
	windowFlags:
	Data.i #PB_Window_SystemMenu, #PB_Window_MinimizeGadget, #PB_Window_MaximizeGadget, #PB_Window_SizeGadget    
	Data.i #PB_Window_Invisible, #PB_Window_TitleBar, #PB_Window_Tool, #PB_Window_BorderLess    
	Data.i #PB_Window_ScreenCentered, #PB_Window_WindowCentered, #PB_Window_Maximize, #PB_Window_Minimize      
	Data.i #PB_Window_NoGadgets, #PB_Window_NoActivate  
	windowFlagNames:
	Data.s "#PB_Window_SystemMenu", "#PB_Window_MinimizeGadget", "#PB_Window_MaximizeGadget", "#PB_Window_SizeGadget"
	Data.s "#PB_Window_Invisible", "#PB_Window_TitleBar", "#PB_Window_Tool", "#PB_Window_BorderLess"
	Data.s "#PB_Window_ScreenCentered", "#PB_Window_WindowCentered", "#PB_Window_Maximize", "#PB_Window_Minimize" 
	Data.s "#PB_Window_NoGadgets", "#PB_Window_NoActivate"
EndDataSection

#countWindowFlags = 14

Structure flagInfo
	value.i 
	name.s
EndStructure

Global NewMap windowFlagConstantNames.s()
Dim flags.flagInfo(#countWindowFlags - 1)

Define i
Restore windowFlags
For i = 0 To #countWindowFlags - 1
 ; http://www.purebasic.fr/english/viewtopic.php?f=13&t=61743
Read.i flags(i)\Value
Next
Restore windowFlagNames
For i = 0 To #countWindowFlags - 1
	Read.s flags(i)\name
	windowFlagConstantNames(StrU(flags(i)\value, #PB_Long)) = flags(i)\name
Next

;macros for showWindowFlags()
Macro IfTestFor(flag, c)
	If flag & c = c
		Debug #DQUOTE$ + windowFlagConstantNames(StrU(c, #PB_Long)) + #DQUOTE$
EndMacro
	
Macro EndIfTestFor()  
EndIf
EndMacro

Macro IfETestFor(flag, c)
	IfTestFor(flag, c)
	EndIfTestFor()
EndMacro

Procedure showWindowFlags(flag)
	IfTestFor(flag, #PB_Window_TitleBar)
		IfETestFor(flag, #PB_Window_SizeGadget)
		IfTestFor(flag, #PB_Window_SystemMenu)
			IfETestFor(flag, #PB_Window_MinimizeGadget)
			IfETestFor(flag, #PB_Window_MaximizeGadget)
		EndIfTestFor()
	EndIfTestFor()
	IfETestFor(flag, #PB_Window_Invisible)
	IfETestFor(flag, #PB_Window_Tool)
	IfETestFor(flag, #PB_Window_BorderLess)
	IfETestFor(flag, #PB_Window_ScreenCentered)
	IfETestFor(flag, #PB_Window_WindowCentered)
	IfETestFor(flag, #PB_Window_Maximize)
	IfETestFor(flag, #PB_Window_Minimize)
	IfETestFor(flag, #PB_Window_NoGadgets)
	IfETestFor(flag, #PB_Window_NoActivate)
EndProcedure

Define j, flag, n, x, f$
For i = 1 To 20
	n = Random(2)
	flag = 0
	f$ = ""
	For j = 0 To n
		x = Random(#countWindowFlags - 1)
		flag | flags(x)\value
		f$ +"," + flags(x)\name
	Next
	Debug #CRLF$ + "flag: " + LTrim(f$, ",")
	showWindowFlags(flag)
Next
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 27
; FirstLine = 26
; Folding = -
; EnableXP